
#import "LiveCourseEnterVC.h"
#import <PlayerSDK/PlayerSDK.h>
#import <AVFoundation/AVFoundation.h>
#import "Reachability.h"
#import "SigninPromptController.h"
#import "GSChatView.h"
#import "CommonModel.h"

#import "PrefixHeader.pch"
#import "GenseePlugin.h"
#define SCREEN_WIDTH    MIN([UIScreen mainScreen].bounds.size.width,[UIScreen mainScreen].bounds.size.height)
#define SCREEN_HEIGHT   MAX([UIScreen mainScreen].bounds.size.width,[UIScreen mainScreen].bounds.size.height)
#define IS_IPHONEX              ((SCREEN_HEIGHT >= 812 || SCREEN_WIDTH >= 812) ? YES : NO)
#define NAV_VIEW_HEIGHT (44.0f + ([[UIApplication sharedApplication] statusBarFrame].size.height ? : (IS_IPHONEX ? 44.f : 20.f)))
#define VIDEO_SMALL CGRectMake(0, NAV_VIEW_HEIGHT, SCREEN_WIDTH, (SCREEN_HEIGHT - NAV_VIEW_HEIGHT)/3)
#define VIDEO_BIG CGRectMake(0, 0, SCREEN_HEIGHT, SCREEN_WIDTH)
#define AUDIO_IMAGE_SMALL CGRectMake(0, 0, SCREEN_WIDTH, (SCREEN_HEIGHT - NAV_VIEW_HEIGHT)/3)
#define HANDUP_BTN_SMALL CGRectMake(SCREEN_WIDTH*10/12, SCREEN_HEIGHT/10 - 20, 44, 44)
#define SWITHCH_AUDIO_SMALL CGRectMake(SCREEN_WIDTH*10/12, CGRectGetMaxY(_handupBtn.frame) + 10, 44, 44)
#define SWITHCH_BTN_SMALL CGRectMake(SCREEN_WIDTH*10/12, CGRectGetMaxY(_switchAudioBtn.frame) + 10, 44, 44)
#define SWITHCH_DOC_BTN_SMALL CGRectMake(SCREEN_WIDTH*10/12, CGRectGetHeight(_docView.frame)/2, 44, 44)

#define HANDUP_BTN_BIG CGRectMake(SCREEN_HEIGHT*10/12, SCREEN_WIDTH/2 - 44,44,44)
#define SWITHCH_AUDIO_BIG CGRectMake(SCREEN_HEIGHT*10/12, CGRectGetMaxY(_handupBtn.frame) + 20, 44, 44)
#define SWITHCH_BTN_BIG CGRectMake(SCREEN_HEIGHT*10/12, CGRectGetMaxY(_switchAudioBtn.frame) + 20, 44, 44)
#define SWITHCH_DOC_BTN_BIG CGRectMake(SCREEN_WIDTH*10/12, CGRectGetHeight(_docView.frame)*3/4, 44, 44)
static NSTimeInterval const kSynchronizeTime = 60;
CGFloat const LiveScreenRotateDuration = 0.25;
@interface LiveCourseEnterVC ()<GSPPlayerManagerDelegate,GSDocViewDelegate,SigninPromptDelegate>
@property (nonatomic, strong) GSPPlayerManager *playerManager;
@property (nonatomic, strong) Reachability *internetReachability;
@property (nonatomic, strong) GSPVideoView *videoView;
@property (nonatomic, strong) MBProgressHUD *progressHUD;
@property (nonatomic, strong) UIImageView *audioImg;
@property (nonatomic, strong) UISegmentedControl *segmentControl;
@property (nonatomic, strong) UILabel *segmentBottomView;
@property (nonatomic, strong) GSPDocView *docView;
@property (nonatomic, strong) GSPChatView *chatView;
@property (nonatomic, strong) GSChatView *chatViewnew;
@property (nonatomic, strong) GSPQaView *qaView;
@property (nonatomic, strong) GSPChatInputToolView *inputChatView;
@property (nonatomic, strong) GSPChatInputToolView *inputQaView;
@property (nonatomic, strong) GSPInvestigation *Currentquestionnaire;
@property (nonatomic, strong) UIView *cameraArea;
@property (nonatomic, strong) UIView *topview;
@property (nonatomic, strong) UILabel *topviewtitle;
///调查问卷
@property (nonatomic, strong) GSPInvestigationView *investigationView;
@property (nonatomic, strong) UIButton *switchVideoViewBtn;//切换视频大小
@property (nonatomic, strong) UIButton *switchDocViewBtn;//切换文档大小
@property (nonatomic, strong) UIButton *handupBtn;//举手
@property (nonatomic, strong) UIButton *closecameraAreaBtn;//关闭视频窗口
@property (nonatomic, strong) UIButton *switchAudioBtn;//切换音/视频
@property (nonatomic, assign) BOOL hasOrientation;
@property (nonatomic, assign) BOOL docChangeSize;
@property (nonatomic, assign) BOOL isHandup;
@property (nonatomic, assign) BOOL isAudio;
@property (nonatomic, strong) GSPVideoView *preView; //视频窗口
@property (assign, nonatomic) NSInteger hiddenDelaySeconds;//隐藏时间
@property (assign, nonatomic) NSInteger hiddenHandSeconds;//举手倒计时
@property (nonatomic, assign) BOOL hideView;
@property (strong, nonatomic) NSTimer *timer;//定时器
@property (strong, nonatomic) NSTimer *handTimer;//举手定时器
@property (nonatomic, strong) UIAlertView *alert;
@property (nonatomic, strong) UIButton *Closeinvestigation;//关闭问卷调查
@property (strong, nonatomic) NSMutableArray *investigationsArray;

@property (strong, nonatomic) NSMutableDictionary *investigationDic;

/** 学时记录 */
//@property (nonatomic, strong) NSTimer *recordTimer;
/** 学时记录间隔 */
@property (nonatomic, assign) NSTimeInterval recordTimeInterval;
@property (nonatomic, strong)NSTimer *synchronizeProgressTimer;//同步进度定时器
@property (nonatomic, assign) NSUInteger synchronizeTime;// 60s同步
@end

@implementation LiveCourseEnterVC
{
  
    NSString *_nativeCount;
}

- (void)viewDidLoad {
    [super viewDidLoad];
    self.investigationsArray = [NSMutableArray array];
    self.investigationDic = [NSMutableDictionary dictionary];
    [self createNavViews];
    
    [self joinLiveCourse];
    [self createVideoView];
    [self createSegment];
//    [self creatcameraArea];
    [self createDocView];
    [self createChatView];
    [self createQAView];
    [self addNOtifiReachability];
    [self createinvestigationView];
    //    if (!_model.isOpenlive) { //公开直播与否
    [self setupNotification];
    //        [self.recordModel startRecordTimerWithTarget:self selector:@selector(requestRecordData)];
    //    }
}

- (void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:YES];
   
    [self.navigationController setNavigationBarHidden:NO animated:YES];
    if ([self.navigationController respondsToSelector:@selector(interactivePopGestureRecognizer)]) {
        //禁用右滑手势,这里对添加到右滑视图上的所有手势禁用
        for (UIGestureRecognizer *popGesture in self.navigationController.interactivePopGestureRecognizer.view.gestureRecognizers) {
            popGesture.enabled = NO;
        }
    }
    
    [self addTimer];
    [self addSynchronizeProgressTimer];
}

- (void)viewWillDisappear:(BOOL)animated{
    [super viewWillDisappear:YES];
    [self removeTimer];
    [self removeHandTimer];
    [self removeSynchronizeProgressTimer];
    //    if (_recordModel) {
    //        [_recordModel stopRecordTimer];
    //    }
    
    [self.navigationController setNavigationBarHidden:YES animated:YES];
   
    if ([self.navigationController respondsToSelector:@selector(interactivePopGestureRecognizer)]) {
        //启用右滑手势
        for (UIGestureRecognizer *popGesture in self.navigationController.interactivePopGestureRecognizer.view.gestureRecognizers) {
            popGesture.enabled = YES;
        }
    }
}

#pragma mark ……Yvan…… 设置前后台处理通知
- (void)setupNotification {
    //回到前台
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(appDidBecomeActive) name:UIApplicationDidBecomeActiveNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(appWillResignActive) name:UIApplicationWillResignActiveNotification object:nil];
}

- (void)removeNotification {
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

- (void)appDidBecomeActive {
    //    [LCAlert playNetworkCheckInSourceVC:self playerView:nil recordModel:self.model.isOpenlive ? nil : self.recordModel isOnlineVideo:YES WIFIHandler:^{
    //        [self.playerManager reconnect];
    //    } WWANCancelHanlder:^{
    //        [self popVC];
    //    } WWANConfirmHandler:nil NoConectNetworkOnlineCancelHandler:^{
    //        [self popVC];
    //    }];
    [self.playerManager reconnect];
}

- (void)appWillResignActive {
    [self pauseRecord];
}

- (void)createNavViews{
    //    self.edgesForExtendedLayout
    self.navigationItem.title = self.liveName;
    self.navigationItem.leftBarButtonItem = [[UIBarButtonItem alloc] initWithImage:[UIImage imageNamed:@"navBack_black"] style:UIBarButtonItemStyleDone target:self action:@selector(closePage)];
    self.view.backgroundColor = [UIColor whiteColor];
    
//    self.navigationController.navigationBar.translucent = NO;
}

- (void)closePage {
    NSString *title = @"确定退出该直播？";
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:title message:nil preferredStyle: UIAlertControllerStyleAlert];
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleCancel handler:^(UIAlertAction * _Nonnull action) {
        _investigationView.hidden = YES;
        [_investigationView removeFromSuperview];
        [self.navigationController popViewControllerAnimated:YES];
        [self closelive];
    }];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleDefault handler:nil];
    NSMutableAttributedString *alertControllerStr = [[NSMutableAttributedString alloc] initWithString:title];
    [alertControllerStr addAttribute:NSForegroundColorAttributeName value:[UIColor blackColor] range:NSMakeRange(0, title.length)];
    
    [alertController setValue:alertControllerStr forKey:@"attributedTitle"];
    [cancelAction setValue:[UIColor blackColor] forKey:@"titleTextColor"];
    [okAction setValue:[UIColor blackColor] forKey:@"titleTextColor"];
    [alertController addAction:okAction];
    [alertController addAction:cancelAction];
    [self presentViewController:alertController animated:YES completion:nil];
    
}

- (void)joinLiveCourse{
    _playerManager = [GSPPlayerManager sharedManager];
    _playerManager.httpAPIEnabled = YES;
    _playerManager.delegate =self;
    
    //    GSPJoinParam *param = [GSPJoinParam new];
    //    param.domain = @"training.ttcdw.cn";
    //    param.serviceType = GSBroadcastServiceTypeTraining;
    //    param.roomNumber = @"40830885";
    //    param.watchPassword = @"247006";
    //    param.nickName = @"Cooper";
  BOOL * jo = [_playerManager joinWithParam:self.param];
    if(jo)
    {
        NSLog(@"ssss");
    }else
    {
        NSLog(@"ddd");
    }
    
    //    [_playerManager joinWithParam:param];
    
}

- (void)popVC {
    if (_hasOrientation) {
        [self rotationVideoView:nil];
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(LiveScreenRotateDuration *2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            [self.navigationController popViewControllerAnimated:YES];
        });
    } else {
        [self.navigationController popViewControllerAnimated:YES];
    }
}

#pragma mark - videoView


- (void)createVideoView{
    
    _videoView = [[GSPVideoView alloc]initWithFrame:VIDEO_SMALL];
    _audioImg = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"audio.jpg"]];
    _audioImg.frame = AUDIO_IMAGE_SMALL;
    _audioImg.hidden = YES;
    [_videoView addSubview:_audioImg];
    //举手
    _handupBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    _handupBtn.frame = HANDUP_BTN_SMALL;
    [_handupBtn setImage:[UIImage imageNamed:@"hand"] forState:UIControlStateNormal];
    [_handupBtn addTarget:self action:@selector(handupBtnAction:) forControlEvents:UIControlEventTouchUpInside];
    [_videoView addSubview:_handupBtn];
    //切换音视频
    _switchAudioBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    _switchAudioBtn.frame = SWITHCH_AUDIO_SMALL;
    [_switchAudioBtn setImage:[UIImage imageNamed:@"no_vedio"] forState:UIControlStateNormal];
    [_switchAudioBtn addTarget:self action:@selector(switchAudioBtnAction:) forControlEvents:UIControlEventTouchUpInside];
    [_videoView addSubview:_switchAudioBtn];
    //切换全屏
    _switchVideoViewBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    _switchVideoViewBtn.frame = SWITHCH_BTN_SMALL;
    [_switchVideoViewBtn setImage:[UIImage imageNamed:@"enlarge"] forState:UIControlStateNormal];
    [_switchVideoViewBtn addTarget:self action:@selector(rotationVideoView:) forControlEvents:UIControlEventTouchUpInside];
    [_videoView addSubview:_switchVideoViewBtn];
    
    //视频双击全屏
    UITapGestureRecognizer *tapGestureRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(rotationVideoView:)];
    tapGestureRecognizer.numberOfTapsRequired = 2;
    [_videoView addGestureRecognizer:tapGestureRecognizer];
    
    //视频单击收键盘、隐藏/显示按钮
    UITapGestureRecognizer *singleGestureRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTapGesture:)];
    singleGestureRecognizer.numberOfTapsRequired = 1;
    [singleGestureRecognizer requireGestureRecognizerToFail:tapGestureRecognizer];
    [_videoView addGestureRecognizer:singleGestureRecognizer];
    
    [self.view addSubview:_videoView];
    _playerManager.videoView = _videoView;
    _videoView.contentMode = UIViewContentModeScaleAspectFit;
    
}
- (void)handupBtnAction:(UIButton *)btn{
    _isHandup = !_isHandup;
    if (_isHandup) {
        //举手成功
        if ([self.playerManager handup:YES]) {
            [_handupBtn setImage:[UIImage imageNamed:@"hand_white"] forState:UIControlStateNormal];
            //开启举手定时器
            [self addHandTimer];
        }
    }else{
        //不举手成功
        if ([self.playerManager handup:NO]) {
            [_handupBtn setImage:[UIImage imageNamed:@"hand"] forState:UIControlStateNormal];
            [_handupBtn setTitle:nil forState:UIControlStateNormal];
            //停止举手定时器
            [self removeHandTimer];
        }
        
    }
}

- (void)switchAudioBtnAction:(UIButton *)btn{
    _isAudio = !_isAudio;
    if (_isAudio) {
        //切换成只是音频成功
        if ([self.playerManager enableVideo:NO]) {
            _audioImg.hidden = NO;
            [_switchAudioBtn setImage:[UIImage imageNamed:@"vedio"] forState:UIControlStateNormal];
        }
    }else{
        //切换成音频+视频成功
        if ([self.playerManager enableVideo:YES]) {
            _audioImg.hidden = YES;
            [_switchAudioBtn setImage:[UIImage imageNamed:@"no_vedio"] forState:UIControlStateNormal];
        }
    }
}

- (void)rotationVideoView:(UIGestureRecognizer *)gestureRecognizer {
    [self.view endEditing:YES];//收起键盘
    [self.navigationController setNavigationBarHidden:!_hasOrientation animated:YES];
    
    
    //强制旋转
    if (!_hasOrientation) {
        [UIView animateWithDuration:LiveScreenRotateDuration animations:^{
            self.view.transform = CGAffineTransformMakeRotation(M_PI/2);
            self.view.bounds = VIDEO_BIG;
            self->_videoView.frame = VIDEO_BIG;
            self->_audioImg.frame = VIDEO_BIG;
            self->_handupBtn.frame = HANDUP_BTN_BIG;
            self->_switchAudioBtn.frame = CGRectMake(SCREEN_HEIGHT*10/12, CGRectGetMaxY(self->_handupBtn.frame) + 20, 44, 44);
            self->_switchVideoViewBtn.frame = CGRectMake(SCREEN_HEIGHT*10/12, CGRectGetMaxY(self->_switchAudioBtn.frame) + 54 , 44, 44);
            self->_hasOrientation = YES;
            _segmentControl.hidden = YES;
            self->_segmentBottomView.hidden = YES;
            [[UIApplication sharedApplication] setStatusBarHidden:YES];
            [self->_switchVideoViewBtn setImage:[UIImage imageNamed:@"shrink_down"] forState:UIControlStateNormal];
            //            [_inputChatView hideUserListView];//切换时隐藏弹出的用户列表
            switch ( _segmentControl.selectedSegmentIndex) {
                case 0:
                    
                    _docView.hidden = YES;
                    
                    break;
                case 1:
                    
                    _chatViewnew.hidden = YES;
                    
                    //                    _inputChatView.hidden = YES;
                    [_chatViewnew endEditing];
                    break;
                case 2:
                    
                    _qaView.hidden = YES;
                    
                    _inputQaView.hidden = YES;
                    break;
                default:
                    break;
            }
        }];
    } else {
        [UIView animateWithDuration:LiveScreenRotateDuration animations:^{
            self.view.transform = CGAffineTransformInvert(CGAffineTransformMakeRotation(0));
            self.view.bounds = CGRectMake(0, 0, SCREEN_WIDTH , SCREEN_HEIGHT);
            self->_videoView.frame = VIDEO_SMALL;
            self->_audioImg.frame = AUDIO_IMAGE_SMALL;
            self->_handupBtn.frame = HANDUP_BTN_SMALL;
            self->_switchAudioBtn.frame = CGRectMake(SCREEN_WIDTH*10/12, CGRectGetMaxY(self->_handupBtn.frame) + 10, 44, 44);
            self->_switchVideoViewBtn.frame = CGRectMake(SCREEN_WIDTH*10/12, CGRectGetMaxY(self->_switchAudioBtn.frame) + 10, 44, 44);
            self->_hasOrientation = NO;
            self->_segmentControl.hidden = NO;
            self->_segmentBottomView.hidden = NO;
            [[UIApplication sharedApplication] setStatusBarHidden:NO];
            [self->_switchVideoViewBtn setImage:[UIImage imageNamed:@"enlarge"] forState:UIControlStateNormal];
            //            [_inputChatView hideUserListView];//切换时隐藏弹出的用户列表
            switch ( _segmentControl.selectedSegmentIndex) {
                case 0:
                    
                    _docView.hidden = NO;
                    
                    break;
                case 1:
                    
                    _chatViewnew.hidden = NO;
                    
                    //                    _inputChatView.hidden = NO;
                    
                    break;
                case 2:
                    
                    _qaView.hidden = NO;
                    
                    _inputQaView.hidden = NO;
                    break;
                default:
                    break;
            }
        }];
    }
}

- (void)handleTapGesture:(UIGestureRecognizer *)gestureRecognizer {
    [self.view endEditing:YES];
    
    if (_hideView) {
        _hideView = NO;
        _handupBtn.hidden = NO;
        _switchAudioBtn.hidden = NO;
        _switchVideoViewBtn.hidden = NO;
        _switchDocViewBtn.hidden = NO;
        _hiddenDelaySeconds = 5;
    }else{
        _hideView = YES;
        _handupBtn.hidden = YES;
        _switchAudioBtn.hidden = YES;
        _switchVideoViewBtn.hidden = YES;
        _switchDocViewBtn.hidden = YES;
        _hiddenDelaySeconds = 0;
    }
}

- (void)addTimer{
    _timer = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(timerHandler) userInfo:nil repeats:YES];
}
- (void)addSynchronizeProgressTimer{
    [self removeSynchronizeProgressTimer];
    _synchronizeTime = kSynchronizeTime;
    if (!_synchronizeProgressTimer) {
        _synchronizeProgressTimer = [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(synchronizeProgressTimerHandler) userInfo:nil repeats:YES];
        [[NSRunLoop currentRunLoop] addTimer:_synchronizeProgressTimer forMode:NSRunLoopCommonModes];
    }
}
- (void)synchronizeProgressTimerHandler{
    _synchronizeTime--;
    if (_synchronizeTime == 0) {
        _synchronizeTime = kSynchronizeTime;
//        [self loadTokenCheck];
    }
}

- (void)removeSynchronizeProgressTimer {
    if (_synchronizeProgressTimer == nil) return;
    [_synchronizeProgressTimer invalidate];
    _synchronizeProgressTimer = nil;
}
/*
//token校验
- (void)loadTokenCheck{
    [SCHttpTool get:TokenCheckUrl token:USER_TOKEN params:nil success:^(id responseObj) {
        [self parseTokenCheck:responseObj];
    } failure:^(NSError *error) {
        NSLog(@"%@",error.localizedDescription);
        NSData *data = [error.userInfo objectForKey:SCNetworkingOperationFailingURLResponseDataErrorKey];
        [self parseTokenCheck:data];
    }];
}

- (void)parseTokenCheck:(NSData *)data{
    if (!data) {
        return;
    }
    CommonDataDictionaryModel *comModel = [CommonDataDictionaryModel mj_objectWithKeyValues:data];
    NSLog(@"%@",[comModel mj_keyValues]);
    [self synchronizeProgress];
    if (!comModel.success && (comModel.resultCode==1101||comModel.resultCode==1102||comModel.resultCode==1103 ||comModel.resultCode==1100)) {
        
        [self removeSynchronizeProgressTimer];
        UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"您已退出登录，请重新登录" message:nil preferredStyle: UIAlertControllerStyleAlert];
        UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            if([SCTools isOrientationLandscape]) {
                [SCTools forceOrientation: UIInterfaceOrientationPortrait];
            }
            [APPDELEGATE pushLoginVC];
        }];
        [alertController addAction:okAction];
        if ([SCTools getAVFullScreenViewController] == nil) {
            [self presentViewController:alertController animated:YES completion:nil];
        }else{
            [[SCTools getAVFullScreenViewController] presentViewController:alertController animated:YES completion:nil];
        }
        return;
    }
}
//同步视频进度
- (void)synchronizeProgress{
    
    NSString *url;
    
    ///v3.4.0 LiveCourseProgressUrl增加itemId
    url = [NSString stringWithFormat:@"https://www.ttcdw.com.cn/api/course/public/course/live/progress/%@",self.courseId];
    if (IsStrEmpty(self.itemId))
    {
        self.itemId = @"";
    }
    NSDictionary *modelDic = @{@"courseId":self.courseId,@"sourceId":self.sourceId,@"sourceType":self.sourceType,@"itemId":self.itemId};
    NSLog(@"同步进度参数：%@",modelDic);
     
    [SCHttpTool post:url token:USER_TOKEN params:modelDic success:^(id responseObj) {
        NSLog(@"同步返回数据：%@",responseObj);
        [self synchronizeProgressParseData:responseObj];
    } failure:^(NSError *error) {
        NSLog(@"%@",error.localizedDescription);
        NSData *data = [error.userInfo objectForKey:SCNetworkingOperationFailingURLResponseDataErrorKey];
        [self synchronizeProgressParseData:data];
    }];
    
}
- (void)synchronizeProgressParseData:(NSData *)data{
    
    if (!data) {
        return;
    }
    CommonDataDictionaryModel *comModel = [CommonDataDictionaryModel mj_objectWithKeyValues:data];
    if (!comModel.success) {
        NSLog(@"******同步返回错误数据：%@,message:%@",[comModel mj_keyValues],comModel.message);
        return;
    }else{
        NSLog(@"******同步成功");
    }
    
}*/
- (void)addHandTimer{
    _hiddenHandSeconds = 60;
    _handTimer = [NSTimer scheduledTimerWithTimeInterval:1.0 target:self selector:@selector(handTimerHandler) userInfo:nil repeats:YES];
}

- (void)timerHandler{
    
    if (_hideView) {
        return;
    }
    _hiddenDelaySeconds --;
    if (_hiddenDelaySeconds <= 0) {
        _hideView = YES;
        _handupBtn.hidden = YES;
        _switchAudioBtn.hidden = YES;
        _switchVideoViewBtn.hidden = YES;
        _switchDocViewBtn.hidden = YES;
    }
    
}

- (void)handTimerHandler{
    if (!_isHandup) {
        return;
    }
    _hiddenHandSeconds --;
    if (_hiddenHandSeconds < 0) {
        [_handTimer invalidate];
        //
        _isHandup = NO;
        [self.playerManager handup:NO];
        if ([self.playerManager handup:NO]) {
            [_handupBtn setImage:[UIImage imageNamed:@"hand"] forState:UIControlStateNormal];
            [_handupBtn setTitle:nil forState:UIControlStateNormal];
        }
    }else{
        [_handupBtn setTitle:[NSString stringWithFormat:@"%ld",_hiddenHandSeconds] forState:UIControlStateNormal];
        _handupBtn.titleLabel.font = [UIFont systemFontOfSize:10];
    }
}

- (void)removeTimer {
    if (_timer == nil) return;
    [_timer invalidate];
    _timer = nil;
    
}
- (void)removeHandTimer{
    if (_handTimer == nil) return;
    [_handTimer invalidate];
    _handTimer = nil;
}

#pragma mark - 记录学时Timer

//- (LCStudyRecordDataModel *)recordModel {
//    if (!_recordModel) {
//        _recordModel = [[LCStudyRecordDataModel alloc] init];
//    }
//    return _recordModel;
//}

- (void)pauseRecord {
    //    if (!self.model.isOpenlive) {
    //        [self.recordModel pauseRecordTimer];
    //    }
}

- (void)contineRecord {
    //    if (!self.model.isOpenlive) {
    //        [self.recordModel continueRecordTimer];
    //    }
}
/*
 - (void)requestRecordData {
 LCStudyLiveGSRecordRequestModel *requestModel = [[LCStudyLiveGSRecordRequestModel alloc] init];
 requestModel.liveCourseId = _model.ID;
 LCWeakSelf;
 [requestModel requestDataWithRefreshWay:nil success:^(LCBaseResponseModel * _Nonnull responseModel) {
 [weakSelf handleRecordDataWithResponseModel:responseModel];
 } failure:^(NSError * _Nonnull error) {
 [weakSelf.recordModel updateRecordLossWithSourceVC:weakSelf handle:nil];
 }];
 }
 
 - (void)handleRecordDataWithResponseModel:(LCBaseResponseModel *)responseModel {
 if (responseModel.isSuccess) {
 LCStudyLiveGSRecordDataModel *model = responseModel;
 [[NSNotificationCenter defaultCenter] postNotificationName:LCNOTIFICATION_STUDY_RECORD_SUCCESS object:nil];
 [self.recordModel resetStudyRecordLoss];
 if (self.recordModel.isRecordFinish) {
 [self.recordModel stopRecordTimer];
 } else {
 self.recordModel.isRecordFinish = (model.progress.integerValue == 100) ? YES : NO;
 if (self.recordModel.isRecordFinish) {
 [self requestRecordData];
 }
 }
 } else {
 [self.recordModel updateRecordLossWithSourceVC:self handle:^{}];
 }
 }
 */
#pragma mark - segment
//通过颜色来生成一个纯色图片
- (UIImage *)buttonImageFromColor:(UIColor *)color{
    
    CGRect rect = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    UIGraphicsBeginImageContext(rect.size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetFillColorWithColor(context, [color CGColor]);
    CGContextFillRect(context, rect);
    UIImage *img = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    return img;
}
-(void)creatcameraArea
{
    _cameraArea = [[UIView alloc]initWithFrame:CGRectMake(ScreenWidth - (ScreenWidth/2 - 10) - 20, ScreenHeight -(ScreenWidth/2 - 10)*3/4 - 20, ScreenWidth/2 - 10, (ScreenWidth/2 - 10)*3/4)];
    _cameraArea.layer.borderColor          = HEXCOLOR(0x009BD8).CGColor;
    _cameraArea.layer.borderWidth          = 0.5f;
    _cameraArea.backgroundColor = [UIColor groupTableViewBackgroundColor];
    _closecameraAreaBtn = [[UIButton alloc]initWithFrame:CGRectMake(0, 0, 44, 44)];
    [_closecameraAreaBtn setImage:[UIImage imageNamed:@"icon_close"] forState:UIControlStateNormal];
    [_closecameraAreaBtn addTarget:self action:@selector(closecameraAreaBtnAction:) forControlEvents:UIControlEventTouchUpInside];
    [_cameraArea addSubview:_closecameraAreaBtn];
    
    [self.view addSubview:_cameraArea];
   
    self.cameraArea.hidden = YES;
}
-(void)closecameraAreaBtnAction:(UIButton *)sendr
{
  
//        [self.playerManager activateCamera:NO];
//        [self.playerManager activateMicrophone:NO];
        [self.playerManager acceptMediaInvitation:NO type:GSPMediaInvitationTypeAudioOnly];
        [self.playerManager acceptMediaInvitation:NO type:GSPMediaInvitationTypeVideoOnly];
        [self.playerManager acceptMediaInvitation:NO type:GSPMediaInvitationTypeAVBoth];
      
        [_preView removeFromSuperview];
        _preView = nil;
        self.cameraArea.hidden = YES;
    
    
}

- (void)createSegment{
    //切换
   
    _segmentControl = [[UISegmentedControl alloc] initWithItems:@[@"文档",@"聊天",@"问答"]];
    [_segmentControl setFrame:CGRectMake(0, (SCREEN_HEIGHT - NAV_VIEW_HEIGHT)/3 + NAVBAR_HEIGHT + 8, SCREEN_WIDTH/2, 40)];
    [_segmentControl addTarget:self action:@selector(segmentControlAction:) forControlEvents:UIControlEventValueChanged];
    //填充色
    _segmentControl.tintColor = [UIColor whiteColor];
    UIImageView *imageView=[[UIImageView alloc]initWithFrame:_segmentControl.frame];
        imageView.backgroundColor=[UIColor whiteColor];
        imageView.image=[self buttonImageFromColor:[UIColor clearColor]];
    
    // 背景图片
    [_segmentControl setBackgroundImage:imageView.image forState:UIControlStateNormal barMetrics:UIBarMetricsDefault];
   
    //分割线图片
    [_segmentControl setDividerImage:[UIImage imageNamed:@"wihtline_icon"]  forLeftSegmentState:UIControlStateNormal rightSegmentState:UIControlStateNormal barMetrics:UIBarMetricsDefault];
    _segmentControl.backgroundColor = [UIColor whiteColor];
    _segmentControl.selectedSegmentIndex = 0;
    //未选中状态文字颜色
    [_segmentControl setTitleTextAttributes:@{NSFontAttributeName:[UIFont systemFontOfSize:16], NSForegroundColorAttributeName:HEXCOLOR(0x666666)} forState:UIControlStateNormal];
    //选中状态文字颜色
    [_segmentControl setTitleTextAttributes:@{NSFontAttributeName:[UIFont systemFontOfSize:16], NSForegroundColorAttributeName:HEXCOLOR(0x333333)} forState:UIControlStateSelected];
    [self.view addSubview:_segmentControl];
    
    //
    _segmentBottomView = [[UILabel alloc] initWithFrame:CGRectMake(0, 0, SCREEN_WIDTH /24, 4)];
    _segmentBottomView.layer.masksToBounds = YES;
    _segmentBottomView.layer.cornerRadius = 2;
    _segmentBottomView.center=  CGPointMake(SCREEN_WIDTH /12, CGRectGetMaxY(_segmentControl.frame));
    _segmentBottomView.backgroundColor = HEXCOLOR(0x3B70FF);
    [self.view addSubview:_segmentBottomView];
    [self creatcameraArea];
}

- (void)segmentControlAction:(UISegmentedControl *)segment{
    NSInteger index = segment.selectedSegmentIndex;
    //    [_inputChatView hideUserListView];//切换时隐藏弹出的用户列表
    switch (index) {
        case 0:
            _segmentBottomView.center=  CGPointMake(SCREEN_WIDTH /12, CGRectGetMaxY(_segmentControl.frame));
            _docView.hidden = NO;
            _chatViewnew.hidden = YES;
            _qaView.hidden = YES;
            //            _inputChatView.hidden = YES;
            [_chatViewnew endEditing];
            _inputQaView.hidden = YES;
            break;
        case 1:
            _segmentBottomView.center= CGPointMake(SCREEN_WIDTH /4, CGRectGetMaxY(_segmentControl.frame));
            _docView.hidden = YES;
            _chatViewnew.hidden = NO;
            _qaView.hidden = YES;
            //            _inputChatView.hidden = NO;
            _inputQaView.hidden = YES;
            break;
        case 2:
            _segmentBottomView.center= CGPointMake(SCREEN_WIDTH *5/12, CGRectGetMaxY(_segmentControl.frame));
            _docView.hidden = YES;
            _chatViewnew.hidden = YES;
            _qaView.hidden = NO;
            //            _inputChatView.hidden = YES;
            [_chatViewnew endEditing];
            _inputQaView.hidden = NO;
            break;
        default:
            break;
    }
}
#pragma mark - xxxDELEGATE

- (BOOL)gestureRecognizerShouldBegin:(UIGestureRecognizer *)gestureRecognizer {
    
    return YES;
}
#pragma mark - docView

- (void)createDocView{
    _docView = [[GSPDocView alloc] initWithFrame:CGRectMake(0, CGRectGetMaxY(_segmentBottomView.frame), SCREEN_WIDTH, (SCREEN_HEIGHT - NAV_VIEW_HEIGHT)*2/3 - CGRectGetHeight(_segmentControl.frame))];
    _docView.delegate = self;
    _docView.backgroundColor = [UIColor whiteColor];
    [self.view addSubview:_docView];
    _playerManager.docView = _docView;
    
    //文档双击全屏
    UITapGestureRecognizer *tapGestureRecognizerDoc = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(tapDoc:)];
    tapGestureRecognizerDoc.numberOfTapsRequired = 2;
    [_docView addGestureRecognizer:tapGestureRecognizerDoc];
    
    //文档单击收键盘、隐藏/显示按钮
    UITapGestureRecognizer *singleGestureRecognizer = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(handleTapGesture:)];
    singleGestureRecognizer.numberOfTapsRequired = 1;
    [singleGestureRecognizer requireGestureRecognizerToFail:tapGestureRecognizerDoc];
    [_docView addGestureRecognizer:singleGestureRecognizer];
    
    //
    _switchDocViewBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    _switchDocViewBtn.frame = SWITHCH_DOC_BTN_SMALL;
    [_switchDocViewBtn setImage:[UIImage imageNamed:@"enlarge"] forState:UIControlStateNormal];
    [_switchDocViewBtn addTarget:self action:@selector(tapDoc:) forControlEvents:UIControlEventTouchUpInside];
    [_docView addSubview:_switchDocViewBtn];
}

- (void)tapDoc:(UIGestureRecognizer *)gestureRecognizer{
    
    [self.view endEditing:YES];
    if (!_docChangeSize) {
        _docView.frame = CGRectMake(0, NAV_VIEW_HEIGHT, SCREEN_WIDTH, SCREEN_HEIGHT-NAV_VIEW_HEIGHT);
        _switchDocViewBtn.frame = SWITHCH_DOC_BTN_BIG;
        [_switchDocViewBtn setImage:[UIImage imageNamed:@"shrink_down"] forState:UIControlStateNormal];
        _docChangeSize = YES;
    }else{
        _docView.frame = CGRectMake(0, CGRectGetMaxY(_segmentControl.frame), SCREEN_WIDTH, (SCREEN_HEIGHT - NAV_VIEW_HEIGHT)*2/3 - CGRectGetHeight(_segmentControl.frame));
        _switchDocViewBtn.frame = SWITHCH_DOC_BTN_SMALL;
        [_switchDocViewBtn setImage:[UIImage imageNamed:@"enlarge"] forState:UIControlStateNormal];
        _docChangeSize = NO;
    }
    
}


#pragma mark - chatView

- (void)createChatView{
    _chatViewnew = [[GSChatView alloc]initWithFrame:CGRectMake(0, CGRectGetMaxY(_segmentBottomView.frame) , SCREEN_WIDTH, (SCREEN_HEIGHT - NAV_VIEW_HEIGHT)*2/3 - CGRectGetHeight(_segmentControl.frame))];
    _chatViewnew.hidden = YES;
    [self.view addSubview:_chatViewnew];
    
    //    _playerManager.chatView = _chatView;
    //    //
    //    _inputChatView= [[GSPChatInputToolView alloc]initWithViewController:self combinedChatView:_chatView combinedQaView:nil isChatMode:YES];
    //    _inputChatView.hidden = YES;
    //    [self.view addSubview:_inputChatView];
    //    //
    //    UITapGestureRecognizer *tapGestureRecognizer = [[UITapGestureRecognizer alloc]initWithTarget:self action:@selector(hideChatView:)];
    //    [_chatView addGestureRecognizer:tapGestureRecognizer];
}

- (void)hideChatView:(UIGestureRecognizer *)recognizer {
    
    //    [_inputChatView hideUserListView];
    [self.view endEditing:YES];
}

#pragma mark - QAView
- (void)createQAView{
    _qaView = [[GSPQaView alloc] initWithFrame:CGRectMake(0, CGRectGetMaxY(_segmentBottomView.frame), SCREEN_WIDTH, (SCREEN_HEIGHT - NAV_VIEW_HEIGHT)*2/3 - CGRectGetHeight(_segmentControl.frame) - 52)];
    _qaView.hidden = YES;
    [self.view addSubview:_qaView];
    _playerManager.qaView  = _qaView;
    
    _inputQaView = [[GSPChatInputToolView alloc] initWithViewController:self combinedChatView:nil combinedQaView:_qaView isChatMode:NO];
    
    _inputQaView.hidden = YES;
    _inputQaView.frame = CGRectMake(0, SCREEN_HEIGHT - 52, ScreenWidth, 52);
    [self.view addSubview:_inputQaView];
}
-(void)createinvestigationView
{
    _investigationView = [[GSPInvestigationView alloc]initWithFrame:CGRectMake(0, NAVBAR_HEIGHT, SCREEN_WIDTH, SCREEN_HEIGHT-NAVBAR_HEIGHT)];
    _investigationView.backgroundColor = [UIColor whiteColor];
    //    _investigationView.translatesAutoresizingMaskIntoConstraints = NO;
    _investigationView.hidden = YES;
    _topview = [[UIView alloc]initWithFrame:CGRectMake(0, 0,SCREEN_WIDTH , NAVBAR_HEIGHT)];
    _topview.backgroundColor = [UIColor whiteColor];
    
    //    [_investigationView addSubview:_topview];
    _topviewtitle = [[UILabel alloc]initWithFrame:CGRectMake(30, NAVBAR_HEIGHT/2, ScreenWidth - 60,30 )];
    _topviewtitle.textColor = [UIColor blackColor];
    _topviewtitle.textAlignment = NSTextAlignmentCenter;
    [_topview addSubview:_topviewtitle];
    _Closeinvestigation = [UIButton buttonWithType:UIButtonTypeCustom];
    _Closeinvestigation.frame = CGRectMake(ScreenWidth - 30, NAVBAR_HEIGHT/2, 30, 30);
    [_Closeinvestigation setImage:[UIImage imageNamed:@"icon_close"] forState:UIControlStateNormal];
    [_Closeinvestigation addTarget:self action:@selector(CloseinvestigationAction:) forControlEvents:UIControlEventTouchUpInside];
    [_investigationView addSubview:_Closeinvestigation];
    
    _playerManager.investigationView = _investigationView;
    
    
    //    [self.view addSubview:_investigationView];
    [self.navigationController.view addSubview:_investigationView];
    
}
-(void)CloseinvestigationAction:(UIButton *)sender
{
    if (_investigationView.hasForceInvestigation) {
        
        
        UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"强制投票" message:@"不能返回，请投票" preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction * confirmAction  = [UIAlertAction actionWithTitle:@"知道了" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {}];
        [alertController addAction:confirmAction];
        [self presentViewController:alertController animated:YES completion:nil];
    } else {
        _investigationView.hidden = YES;
    }
    
}

#pragma mark - Reachability

- (void)addNOtifiReachability{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(reachabilityChanged:) name:kReachabilityChangedNotification object:nil];
    
    self.internetReachability = [Reachability reachabilityForInternetConnection];
    [self.internetReachability startNotifier];
    [self updateInterfaceWithReachability:self.internetReachability];
}

- (void) reachabilityChanged:(NSNotification *)note
{
    Reachability* curReach = [note object];
    NSParameterAssert([curReach isKindOfClass:[Reachability class]]);
    
    [self updateInterfaceWithReachability:curReach];
}

- (void)updateInterfaceWithReachability:(Reachability *)reachability {
    if(self.playerManager == nil)
    {
        return;
    }
    if (reachability == self.internetReachability) {
        [self.playerManager reconnect];
    }
    if ([[Reachability reachabilityForInternetConnection] currentReachabilityStatus] == ReachableViaWWAN){
        
            UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"流量提醒" message:@"当前非WiFi网络，您已开启”允许3G/4G网络播放视频“，是否继续播放？" preferredStyle: UIAlertControllerStyleAlert];
            
            UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"继续播放" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                //                [self.playerManager reconnect];
            }];
            UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消播放" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
                [self popVC];
            }];
            [alertController addAction:okAction];
            [alertController addAction:cancelAction];
            [self presentViewController:alertController animated:YES completion:nil];
            return;
        
    }
}
- (void)playerManagerWillReconnect:(GSPPlayerManager *)playerManager {
    if (_progressHUD != nil) {
        [_progressHUD hide:YES];
        _progressHUD = nil;
    }
    _progressHUD = [[MBProgressHUD alloc] initWithView:self.view];
    _progressHUD.labelText = NSLocalizedString(@"断线重连", @"");
    [self.view addSubview:_progressHUD];
    [_progressHUD show:YES];
}


#pragma mark - GSPPlayerManagerDelegate


///第三方投票URL
- (void)playerManager:(GSPPlayerManager *)playerManager onThirdVoteUrl:(NSString *)urlStr {
//    NSLog(@"onThirdVoteUrl : %@",urlStr);
//    BaseWebViewController *wordVC = [[BaseWebViewController alloc] init];
//    //    wordVC.navTitle = @"直播课程";
//    wordVC.urlStr =urlStr;
//    wordVC.frame = CGRectMake(0, 0, SCREEN_WIDTH, SCREEN_HEIGHT - NAVBAR_HEIGHT);
//    [self.navigationController pushViewController:wordVC animated:YES];
}
/**
 *  提交问卷调查
 *
 *  @param inves 问卷调查对象
 *
 *  @return 操作是否成功
 */
- (BOOL)submitInvestigation:(GSPInvestigation*)inves
{
    if ([self.playerManager submitInvestigation:inves] )
    {
        return YES;
    }
    
    return NO;
}

//5.2.22 收到问卷调查
- (void)playerManager:(GSPPlayerManager *)playerManager didReceiveInvestigation:(NSArray*)investigations
{
    _topviewtitle.text = @"调查问卷";//self.Currentquestionnaire.theme;
    _investigationView.hidden = NO;
}
- (void)playerManager:(GSPPlayerManager *)playerManager didReceiveSelfJoinResult:(GSPJoinResult)joinResult currentIDC:(NSString*)idcKey{
    NSString *result = @"";
    switch (joinResult) {
        case GSPJoinResultCreateRtmpPlayerFailed:
            result = @"创建直播实例失败，请重新尝试";
            break;
        case GSPJoinResultJoinReturnFailed:
            result = @"调用加入直播失败，请重新尝试";
            break;
        case GSPJoinResultNetworkError:
            result = @"无法连接，请检查网络";
            break;
        case GSPJoinResultUnknowError:
            result = @"发生未知错误";
            break;
        case GSPJoinResultThirdTokenError:
            result = @"第三方认证（用户权限校验）失败";
            break;
        case GSPJoinResultParamsError:
            result = @"参数不正确";
            break;
        case GSPJoinResultREJOIN:
            result = @"您已通过其他客户端进入该直播间";
            break;
        case GSPJoinResultOK:
            result = @"加入成功";
            break;
        case GSPJoinResultCONNECT_FAILED:
            result = @"连接失败，请重新尝试";
            break;
        case GSPJoinResultTimeout:
            result = @"页面已超时失效或直播已结束，请重新进入";
            break;
        case GSPJoinResultRTMP_FAILED:
            result = @"链接媒体服务器失败";
            break;
        case GSPJoinResultTOO_EARLY:
            result = @"直播还未开始";
            break;
        case GSPJoinResultLICENSE:
            result = @"直播间人数已满，无法进入";
            break;
        case GSPJoinResultIP_FORBID:
            result = @"抱歉，您的ip已被封禁";
            break;
        case GSPJoinResultRoomExpired:
            result = @"该直播间已过期";
            break;
        case GSPJoinResultJoinCastPasswordError:
            result = @"口令错误，请联系管理员";
            break;
        default:
            result = @"发生未知错误，请重新尝试";
            break;
    }
    //用于断线重连
    if (_progressHUD != nil) {
        [_progressHUD hide:YES];
        _progressHUD = nil;
    }
    
    if ([result isEqualToString:@"加入成功"]) {
        [SCTools showSuccessWithStatus:result];
    }else if([result isEqualToString:@"抱歉，您的ip已被封禁"]||[result isEqualToString:@"直播还未开始"]||[result isEqualToString:@"连接失败，请重新尝试"] ||[result isEqualToString:@"直播间人数已满，无法进入"]||[result isEqualToString:@"抱歉，您的ip已被封禁"]||[result isEqualToString:@"参数不正确"]||[result isEqualToString:@"发生未知错误"]||[result isEqualToString:@"该直播间已过期"]||[result isEqualToString:@"连接失败，请重新尝试"])
    {
        
        [SCTools showSuccessWithStatus:result];
        if(![result isEqualToString:@"直播还未开始"])
        {
            [self popVC];
        }
        
    }else {
        NSString *messg = [NSString stringWithFormat:@"%@",result];
        UIAlertController *alertController = [UIAlertController alertControllerWithTitle:@"提示" message:messg preferredStyle: UIAlertControllerStyleAlert];
        UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            
            
            [self popVC];
        }];
        
        NSMutableAttributedString *alertControllerStr = [[NSMutableAttributedString alloc] initWithString:@"提示"];
        [alertControllerStr addAttribute:NSForegroundColorAttributeName value:[UIColor blackColor] range:NSMakeRange(0, 2)];
        
        [alertController setValue:alertControllerStr forKey:@"attributedTitle"];
        [okAction setValue:HEXCOLOR(0x3B70FF) forKey:@"titleTextColor"];
        NSMutableAttributedString *alertControllerMessageStr = [[NSMutableAttributedString alloc] initWithString:messg];
        [alertControllerMessageStr addAttribute:NSForegroundColorAttributeName value:HEXCOLOR(0x969799) range:NSMakeRange(0, messg.length)];
        
        [alertController setValue:alertControllerMessageStr forKey:@"attributedMessage"];
        [alertController addAction:okAction];
        [self presentViewController:alertController animated:YES completion:nil];
    }
}

- (void)playerManager:(GSPPlayerManager *)playerManager didSelfLeaveFor:(GSPLeaveReason)reason {
    NSString *reasonStr = nil;
    switch (reason) {
        case GSPLeaveReasonEjected:
            reasonStr = @"抱歉，您已被踢出";
            break;
        case GSPLeaveReasonTimeout:
            reasonStr =  @"页面超时或直播已经结束!请重新进入";
            break;
        case GSPLeaveReasonReLogin:
            reasonStr =  @"您已被踢出";
            break;
        case GSPLeaveReasonClosed:
            reasonStr = @"本次直播已结束，谢谢观看";
            if (self.liveClosedHandler) {
                self.liveClosedHandler();
            }
            break;
        case GSPLeaveReasonUnknown:
            reasonStr = @"您退出直播间，请重新尝试进入";
            break;
        default:
            break;
    }
    if ([reasonStr isEqualToString:@"您已被踢出"] || [reasonStr isEqualToString:@"抱歉，您已被踢出"])
    {
        [SCTools showSuccessWithStatus:reasonStr];
        [self popVC];
    }else
    {
        if (reasonStr != nil) {
        UIAlertController *alertController = [UIAlertController alertControllerWithTitle:[NSString stringWithFormat:@"%@",reasonStr] message:nil preferredStyle: UIAlertControllerStyleAlert];
        UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
            
            
            [self popVC];
        }];
        [alertController addAction:okAction];
        [self presentViewController:alertController animated:YES completion:nil];
        
    }
    }
}



-(void)Livesignin
{
    if( [self.playerManager replyRollCall:YES])
    {
        [SCTools showSuccessWithStatus:@"签到成功"];
    }else
    {
        [SCTools showSuccessWithStatus:@"签到失败"];
    }
    [[NSNotificationCenter defaultCenter]postNotificationName:Face_signindismiss object:nil];
}
///直播签到倒计时结束
- (void)CountdownOver {
    
    NSString *messg = @"点名已经结束了，请关注下次点名";
    UIAlertController * alertController = [UIAlertController alertControllerWithTitle:@"提示" message:messg preferredStyle:UIAlertControllerStyleAlert];
    UIAlertAction * confirmAction  = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {}];
    NSMutableAttributedString *alertControllerStr = [[NSMutableAttributedString alloc] initWithString:@"提示"];
    [alertControllerStr addAttribute:NSForegroundColorAttributeName value:[UIColor blackColor] range:NSMakeRange(0, 2)];
    
    [alertController setValue:alertControllerStr forKey:@"attributedTitle"];
    NSMutableAttributedString *alertControllerMessageStr = [[NSMutableAttributedString alloc] initWithString:messg];
    [alertControllerMessageStr addAttribute:NSForegroundColorAttributeName value:HEXCOLOR(0x969799) range:NSMakeRange(0, messg.length)];
    
    [alertController setValue:alertControllerMessageStr forKey:@"attributedMessage"];
    [confirmAction setValue:HEXCOLOR(0x3B70FF) forKey:@"titleTextColor"];
    [alertController addAction:confirmAction];
    [self presentViewController:alertController animated:YES completion:nil];
}




//收到点名
- (void)playerManager:(GSPPlayerManager *)playerManager didReceiveRollCall:(NSUInteger)seconds
{
    //replyRollCall
    NSLog(@"%lu",(unsigned long)seconds);
    SigninPromptController *vc = [[SigninPromptController alloc] initWithNibName:@"SigninPromptController" bundle:nil];
    vc.delegate = self;
    vc.modalPresentationStyle = UIModalPresentationOverCurrentContext;
    vc.actionButtonTitle = @"签到";
    vc.titleLabel.text = @"开始点名";
    //    vc.Nrtitle = [NSString stringWithFormat:@"请在%ld内完成点名签到",seconds];
    vc.type = LiveType;
    vc.second = seconds;
    CATransition *animation = [CATransition animation];
    animation.duration = 0.1;
    animation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    animation.type = kCATransitionFade;
    animation.subtype = kCATransitionFromLeft;
    [self.view.window.layer addAnimation:animation forKey:nil];
    if ([self.navigationController.visibleViewController isKindOfClass:[self class]]) {
        [self presentViewController:vc animated:NO completion:Nil];
    }
    
    
}
/**
 *  直播是否暂停
 *
 *  @param playerManager 调用该代理的直播管理实例
 *  @param isPaused      YES表示直播已暂停，NO表示直播进行中
 */
- (void)playerManager:(GSPPlayerManager *)playerManager isPaused:(BOOL)isPaused {
    NSString *info = isPaused ? @"直播已暂停" : @"直播中";
//    [SCTools showSuccessWithStatus:info];
    GSPChatMessage *chatMessage = [GSPChatMessage new];
    chatMessage.text = info;
    chatMessage.msgID = [NSString stringWithFormat:@"%f",[[NSDate date] timeIntervalSince1970] * 1000]  ;
    chatMessage.senderName = @"";
    chatMessage.senderUserID = 0;
    chatMessage.senderName = @"";
    chatMessage.chatType = GSPChatTypeSystem;
    GSChatModel *model = [[GSChatModel alloc]init];
    model.chatMessage = chatMessage;
    [self.chatViewnew insert:model];
    [self.chatViewnew refresh];
}
//直播间是否允许聊天
- (void)playerManager:(GSPPlayerManager *)playerManager didSetChatEnable:(BOOL)bEnable {

        NSString *info = bEnable ? @"允许聊天":@"禁止聊天";
    self.chatViewnew.chatToolbar.bEnable = bEnable;
//        [SCTools showSuccessWithStatus:info];
    GSPChatMessage *chatMessage = [GSPChatMessage new];
    chatMessage.text = info;
    chatMessage.msgID = [NSString stringWithFormat:@"%f",[[NSDate date] timeIntervalSince1970] * 1000]  ;
    chatMessage.senderName = @"";
    chatMessage.senderUserID = 0;
    chatMessage.senderName = @"";
    chatMessage.chatType = GSPChatTypeSystem;
    GSChatModel *model = [[GSChatModel alloc]init];
    model.chatMessage = chatMessage;
    [self.chatViewnew insert:model];
    [self.chatViewnew refresh];
    
}
- (void)playerManager:(GSPPlayerManager*)playerManager isSelfMute:(BOOL)bMute {//自己是否被禁止聊天和问答
    NSString *info = bMute ? @"禁止聊天":@"允许聊天";
    self.chatViewnew.chatToolbar.bMute = !bMute;
    GSPChatMessage *chatMessage = [GSPChatMessage new];
    chatMessage.text = info;
    chatMessage.msgID = [NSString stringWithFormat:@"%f",[[NSDate date] timeIntervalSince1970] * 1000]  ;
    chatMessage.senderName = @"";
    chatMessage.senderUserID = 0;
    chatMessage.senderName = @"";
    chatMessage.chatType = GSPChatTypeSystem;
    GSChatModel *model = [[GSChatModel alloc]init];
    model.chatMessage = chatMessage;
    [self.chatViewnew insert:model];
    [self.chatViewnew refresh];
//    [SCTools showSuccessWithStatus:info];
}
//chatView
/**
 *  有用户加入了直播，会调用此代理
 *
 *  @param playerManager 调用该代理的直播管理实例
 *  @param userInfo      加入的用户的用户信息
 */
- (void)playerManager:(GSPPlayerManager *)playerManager didUserJoin:(GSPUserInfo *)userInfo
{
    
    [self.chatViewnew insertuserinfo:userInfo];
}

/**
 *  有用户离开了直播，会调用此代理
 *
 *  @param playerManager 调用该代理的直播管理实例
 *  @param userInfo      离开的用户的用户信息
 */
- (void)playerManager:(GSPPlayerManager *)playerManager didUserLeave:(GSPUserInfo *)userInfo
{
    [self.chatViewnew removeuserinfo:userInfo];
}
/**
 *  收到聊天信息代理
 *
 *  @param playerManager 调用该代理的直播管理实例
 *  @param message       收到的聊天信息
 */
- (void)playerManager:(GSPPlayerManager*)playerManager didReceiveChatMessage:(GSPChatMessage*)message
{
    
    GSChatModel *model = [[GSChatModel alloc]initWithModel:message type: message.chatType];
    [self.chatViewnew insert:model];
    [self.chatViewnew refresh];
}
- (void)playerManager:(GSPPlayerManager *)playerManager OnChatcensor:(NSString *)strType msgID:(NSString *)strMsgId {
    if ([strType isEqualToString:@"msg"]) {
        [self.chatViewnew removeByMessage:strMsgId];
    } else {
        [self.chatViewnew removeByUser:strMsgId];
    }
}


//双师中，主课与分课切换，清空本地聊天记录。重新入会时，会推当前会议的聊天历史记录
- (void)playerManager:(GSPPlayerManager *)playerManager onDoubleTeacherStatusChange:(GSDTStatus)satus
{
    [self.chatViewnew onDoubleTeacherStatusChange];
}


- (void)playerManager:(GSPPlayerManager *)playerManager  didReceiveMediaInvitation:(GSPMediaInvitationType)type action:(BOOL)on
{
    [_alert dismissWithClickedButtonIndex:1 animated:YES];
    
    if (GSPMediaInvitationTypeAudioOnly == type) {
        
        if (on) {
            
            if (!_alert) {
                _alert = [[UIAlertView alloc]initWithTitle:nil message:NSLocalizedString(@"直播间邀请您语音对话", nil)  delegate:self cancelButtonTitle:NSLocalizedString(@"拒绝", nil) otherButtonTitles:NSLocalizedString(@"接受", nil), nil];
                _alert.tag = 999;
                
            }
            [_alert show];
        }
        else
        {
//            [playerManager activateMicrophone:NO];
            
            [playerManager acceptMediaInvitation:NO type:type];
            
        }
    }else if(GSPMediaInvitationTypeVideoOnly == type)
    {
        if (on)
        {
            if (!_alert) {
                _alert = [[UIAlertView alloc]initWithTitle:nil message:NSLocalizedString(@"直播间邀请您视频对话", nil)  delegate:self cancelButtonTitle:NSLocalizedString(@"拒绝", nil) otherButtonTitles:NSLocalizedString(@"接受", nil), nil];
                _alert.tag = 1000;
                
            }
            [_alert show];
        }else
        {
           
          
            [_preView removeFromSuperview];
            _preView = nil;
            self.cameraArea.hidden = YES;
//            [playerManager activateCamera:NO];
            
            [playerManager acceptMediaInvitation:NO type:type];
        }
        
    }else
    {
        if (on)
        {
            if (!_alert) {
                _alert = [[UIAlertView alloc]initWithTitle:nil message:NSLocalizedString(@"直播间邀请您视频对话", nil)  delegate:self cancelButtonTitle:NSLocalizedString(@"拒绝", nil) otherButtonTitles:NSLocalizedString(@"接受", nil), nil];
                _alert.tag = 1001;
                
            }
            [_alert show];
        }else
        {
            [_preView removeFromSuperview];
            _preView = nil;
            self.cameraArea.hidden = YES;
//            [playerManager activateCamera:NO];
//            [playerManager activateMicrophone:NO];
            [playerManager acceptMediaInvitation:NO type:type];
        }
    }
}

- (void)playerManager:(GSPPlayerManager *)playerManager  didReceiveMediaScreenStatus:(BOOL)bIsOpen
{
    NSLog(@"didReceiveMediaScreenStatus=%d",bIsOpen);
    
}

- (void)playerManager:(GSPPlayerManager *)playerManager  didReceiveMediaModuleFocus:(GSModuleFocusType)focus
{
    
    NSLog(@"didReceiveMediaModuleFocus=%lu",(unsigned long)focus);
}


-(void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex
{
    if (alertView.tag == 999 && buttonIndex == 1) {
        
//        [self.playerManager activateMicrophone:YES];
        [self.playerManager acceptMediaInvitation:YES type:GSPMediaInvitationTypeAudioOnly];
        
    }
    else if (alertView.tag == 999 && buttonIndex == 0) {
        [self.playerManager acceptMediaInvitation:NO type:GSPMediaInvitationTypeAudioOnly];
    }
    if (alertView.tag == 1000 && buttonIndex == 1) {
        [_preView removeFromSuperview];
        _preView = [[GSPVideoView alloc]initWithFrame:self.cameraArea.bounds];
        [self.cameraArea addSubview:_preView];
        self.cameraArea.hidden = NO;
        _preView.contentMode = UIViewContentModeScaleAspectFit;
        self.playerManager.preview = _preView;
        [self.playerManager acceptMediaInvitation:YES type:GSPMediaInvitationTypeVideoOnly];
//        [self.playerManager activateCamera:YES];
        self.playerManager.beautifyFace = YES;
        [_cameraArea bringSubviewToFront: _closecameraAreaBtn];
        [self.view bringSubviewToFront: _cameraArea];
    }
    else if (alertView.tag == 1000 && buttonIndex == 0) {
        [self.playerManager acceptMediaInvitation:NO type:GSPMediaInvitationTypeVideoOnly];
    }
    if (alertView.tag == 1001 && buttonIndex == 1) {
        [_preView removeFromSuperview];
        _preView = [[GSPVideoView alloc]initWithFrame:self.cameraArea.bounds];
        [self.cameraArea addSubview:_preView];
        self.cameraArea.hidden = NO;
        _preView.contentMode = UIViewContentModeScaleAspectFit;
        self.playerManager.preview = _preView;
        [self.playerManager acceptMediaInvitation:YES type:GSPMediaInvitationTypeAVBoth];
//        [self.playerManager activateMicrophone:YES];
//        [self.playerManager activateCamera:YES];
        self.playerManager.beautifyFace = YES;
        [_cameraArea bringSubviewToFront: _closecameraAreaBtn];
        [self.view bringSubviewToFront: _cameraArea];
    }
    else if (alertView.tag == 1001 && buttonIndex == 0) {
        [self.playerManager acceptMediaInvitation:NO type:GSPMediaInvitationTypeAVBoth];
    }
    _alert = nil;
}

#pragma mark -

- (void)dealloc {
//    [self.playerManager activateMicrophone:NO];
    [self.playerManager leave];
    [self removeNotification];
}



-(void)closelive
{
     [self repeatAddNativeCount];
}

- (void)repeatAddNativeCount{
    NSLog(@"重复传值执行");
    _nativeCount = @"我是iOS 传过来的字典哦";
    NSDictionary *dic = @{@"key":_nativeCount};
    //通过桥梁传值
    if (_eventSink) {
        _eventSink(dic);
    }
}




@end

//}
