//
//  SCCountDownConfig.m
//  BaseStudyCommune
//
//  Created by GRT's iMac on 2021/4/7.
//  Copyright © 2021 enaea. All rights reserved.
//

#import "SCCountDownConfig.h"
#import "PrefixHeader.pch"
@implementation SCCountDownConfig

- (instancetype)init {
    if (self = [super init]) {
        //初始化默认值
        self.textColor = HEXCOLOR(0x333333);
        self.numColor = [UIColor whiteColor];
        self.textFont = [UIFont systemFontOfSize:16.f];
        self.numFont = [UIFont systemFontOfSize:15.f];
        self.bgColor = [UIColor whiteColor];
        self.textBgColor = [UIColor whiteColor];
        self.numBgColor = HEXCOLOR(0x3B70FF);
        self.textCornerRadius = 3.f;
        self.textLabelSize = CGSizeMake(13.f, 20.f);
        self.margin = 6.f;
        self.space = 2.f;
        self.unitSize = CGSizeMake(6.f, 17.5);
        self.scrollAnimatedEnabled = YES;
    }
    return self;
}

- (CGFloat)getTotalWidthWithCurrentTime:(NSInteger)currentTime {
    if (currentTime <= 0) {
        return 0;
    }
    CGFloat width = 213.f;
    if (currentTime >= 24*60*60) {
        NSInteger day = currentTime/(3600*24);
        NSString *dayStr = [NSString stringWithFormat:@"%ld天", day];
        CGSize daySize = [self sizeWithString:dayStr font:self.textFont maxSize:CGSizeMake(MAXFLOAT, self.textLabelSize.height)];
        width = width + daySize.width + 3;
    } else if (currentTime >= 60*60) {
        width = width + 37.f;
    }
    return width;
}

//获取字符串size
- (CGSize)sizeWithString:(NSString *)string font:(UIFont *)font maxSize:(CGSize)maxSize{
    if (!string) {
        return CGSizeZero;
    }
    NSDictionary *dict = @{NSFontAttributeName : font};
    CGSize size = [string boundingRectWithSize:maxSize options:NSStringDrawingUsesLineFragmentOrigin attributes:dict context:nil].size;
    return size;
}

@end
