//
//  SCTools.m
//  StudyCommune
//
//  Created by tech on 16/2/2.
//  Copyright © 2016年 tech. All rights reserved.
//

#import "SCTools.h"
#import "PrefixHeader.pch"
#import "SVProgressHUD.h"
#import "Reachability.h"

#import "JSHAREService.h"
#import <CommonCrypto/CommonDigest.h>
#import <CommonCrypto/CommonCryptor.h>
@implementation SCTools

+ (UIAlertController *)alertWithMessage:(NSString *)msg{
    
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:msg message:nil preferredStyle: UIAlertControllerStyleAlert];
    
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:nil];
    
    [alertController addAction:okAction];
    
    return alertController;
    
}

+ (UIAlertController *)alertWithTitle:(NSString *)title message:(NSString *)msg{
    
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:title message:msg preferredStyle: UIAlertControllerStyleAlert];
    
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:nil];
    
    [alertController addAction:okAction];
    
    return alertController;
    
}

+ (UIAlertController *)successAlertWithMessage:(NSString *)msg success:(void (^)(void))success{
    
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:msg message:nil preferredStyle: UIAlertControllerStyleAlert];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:nil];
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"确定" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        
        if (success) {
            success();
        }
        
    }];
    
    [alertController addAction:cancelAction];
    [alertController addAction:okAction];
    
    return alertController;
}

+ (UIAlertController *)newsAlertWithTitle:(NSString *)titleMsg withMsg:(NSString *)msg success:(void (^)(void))success{
    UIAlertController *alertController = [UIAlertController alertControllerWithTitle:titleMsg message:msg preferredStyle: UIAlertControllerStyleAlert];
    UIAlertAction *cancelAction = [UIAlertAction actionWithTitle:@"取消" style:UIAlertActionStyleCancel handler:nil];
    UIAlertAction *okAction = [UIAlertAction actionWithTitle:@"查看" style:UIAlertActionStyleDefault handler:^(UIAlertAction * _Nonnull action) {
        
        if (success) {
            success();
        }
        
    }];
    
    [alertController addAction:cancelAction];
    [alertController addAction:okAction];
    
    return alertController;
}

+ (void)showWithStatus:(NSString *) status{
    [SVProgressHUD setDefaultAnimationType:SVProgressHUDAnimationTypeNative];
    //    [SVProgressHUD setDefaultMaskType:SVProgressHUDMaskTypeClear];
    [SVProgressHUD setDefaultStyle:SVProgressHUDStyleDark];
    [SVProgressHUD setMinimumDismissTimeInterval:2];
    [SVProgressHUD setMaximumDismissTimeInterval:5];
    //    [SVProgressHUD setBackgroundColor:[UIColor lightGrayColor]];
    //    [SVProgressHUD setForegroundColor:[UIColor whiteColor]];
    [SVProgressHUD showWithStatus:status];
}

+ (void)showSuccessWithStatus:(NSString *) status{
    [self showWithStatus:status];
    [SVProgressHUD showImage:[UIImage imageNamed:@""] status:status];
}

+ (void)showErrorWithStatus:(NSString *) status{
    [self showWithStatus:status];
    [SVProgressHUD showImage:[UIImage imageNamed:@""] status:status];
}

+ (void)showInfoWithStatus:(NSString*)status{
    //    [SVProgressHUD showInfoWithStatus:status];
    [SVProgressHUD showImage:[UIImage imageNamed:@""] status:status];
}

+ (void)showDismiss{
    [SVProgressHUD dismiss];
}

+ (BOOL)isMobileNumber:(NSString *)mobileNum
{
    NSString * MOBILE = @"^1(3[0-9]|5[0-35-9]|8[025-9])\\d{8}$";
    NSString * CM = @"^1(34[0-8]|(3[5-9]|47|5[0127-9]|78|8[2-478])\\d)\\d{7}$";
    NSString * CU = @"^1(3[0-2]|5[256]|76|8[56]|45)\\d{8}$";
    NSString * CT = @"^1((33|53|7[0-9]|8[019]|49)[0-9]|349)\\d{7}$";
    
    NSPredicate *regextestmobile = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", MOBILE];
    NSPredicate *regextestcm = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", CM];
    NSPredicate *regextestcu = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", CU];
    NSPredicate *regextestct = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", CT];
    if (([regextestmobile evaluateWithObject:mobileNum] == YES)
        || ([regextestcm evaluateWithObject:mobileNum] == YES)
        || ([regextestct evaluateWithObject:mobileNum] == YES)
        || ([regextestcu evaluateWithObject:mobileNum] == YES))
    {
        return YES;
    }
    else
    {
        return NO;
    }
}

+ (BOOL)isMobileNumberSimple:(NSString *)mobileNum{
    
    NSString * MOBILE = @"^1\\d{10}$";
    NSPredicate *regextestmobile = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", MOBILE];
    if ([regextestmobile evaluateWithObject:mobileNum] == YES) {
        return YES;
    }else{
        return NO;
    }
}

/**
 *  邮箱格式检测
 */
+ (BOOL) validateEmail:(NSString *)email {
    NSString *emailRegex = @"[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,4}";
    NSPredicate *emailTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@", emailRegex];
    return [emailTest evaluateWithObject:email];
}

+ (float)folderSizeAtPath:(NSString *)path{
    
    float folderSize = 0.0;
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if ([fileManager fileExistsAtPath:path]) {
        NSArray *childFile = [fileManager subpathsOfDirectoryAtPath:path error:nil];
        for (NSString *fileName in childFile) {
            NSString *absolutePath = [path stringByAppendingPathComponent:fileName];
            folderSize += [[fileManager attributesOfItemAtPath:absolutePath error:nil] fileSize];
        }
        return folderSize / 1024 / 1024;
    }
    return 0;
}

+ (void)clearCacheAtPath:(NSString *)path{
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    if (![fileManager fileExistsAtPath:path]) {
        return;
    }
    
    NSArray *childFile = [fileManager subpathsOfDirectoryAtPath:path error:nil];
    for (NSString *fileName in childFile) {
        NSString *absolutePath = [path stringByAppendingPathComponent:fileName];
        [fileManager removeItemAtPath:absolutePath error:nil];
    }
    
}

+ (NSString *)formatSecondsToString:(NSInteger)seconds
{
    NSString *hhmmss = nil;
    if (seconds < 0) {
        return @"00:00:00";
    }
    
    int h = (int)round((seconds%86400)/3600);
    int m = (int)round((seconds%3600)/60);
    int s = (int)round(seconds%60);
    
    hhmmss = [NSString stringWithFormat:@"%02d:%02d:%02d", h, m, s];
    
    return hhmmss;
}

+ (void)forceOrientation: (UIInterfaceOrientation)orientation {
    if ([[UIDevice currentDevice] respondsToSelector:@selector(setOrientation:)]) {
        SEL selector = NSSelectorFromString(@"setOrientation:");
        NSInvocation *invocation = [NSInvocation invocationWithMethodSignature:[UIDevice instanceMethodSignatureForSelector:selector]];
        [invocation setSelector:selector];
        [invocation setTarget: [UIDevice currentDevice]];
        int val = orientation;
        [invocation setArgument:&val atIndex:2];
        [invocation invoke];
    }
}

+ (BOOL)isOrientationLandscape {
    //if (UIDeviceOrientationIsLandscape([[UIDevice currentDevice] orientation])) {
    if (UIInterfaceOrientationIsLandscape([UIApplication sharedApplication].statusBarOrientation)) {
        return YES;
    } else {
        return NO;
    }
}


+ (BOOL)isBlankString:(NSString *)string{
    
    if (string == nil) {
        
        return YES;
        
    }
    
    if (string == NULL) {
        
        return YES;
        
    }
    
    if ([string isKindOfClass:[NSNull class]]) {
        
        return YES;
        
    }
    
    if ([[string stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] length]==0) {
        
        return YES;
        
    }
    
    return NO;
    
}

+ (BOOL)checkNetWithStatu:(NSString *)status{
    static Reachability *reach;
    if (!reach) {
        reach = [Reachability reachabilityForInternetConnection];
    }
    NetworkStatus netStatus = [reach currentReachabilityStatus];
    if (netStatus == NotReachable) {
        [SCTools showErrorWithStatus:status];
        return YES;
    }else{
        return NO;
    }
}

+ (CAGradientLayer *)gradientColor:(CGRect)frame{
    CAGradientLayer *gradientLayer = [CAGradientLayer layer];
    UIColor *color1= UIColorFromRGB(0x52c9f4);
    UIColor *color2 = UIColorFromRGB(0x5d41d1);
    //    UIColor *color1= [UIColor whiteColor];
    //    UIColor *color2 = [UIColor whiteColor];
    gradientLayer.colors = @[(__bridge id)color1.CGColor, (__bridge id)color2.CGColor];
    gradientLayer.startPoint = CGPointMake(0, 0);
    gradientLayer.endPoint = CGPointMake(1.0, 0);
    gradientLayer.frame = CGRectMake(frame.origin.x, frame.origin.y, SCREEN_WIDTH, frame.size.height);
    return gradientLayer;
}
+ (CAGradientLayer *)gradientColor1:(CGRect)frame{
    CAGradientLayer *gradientLayer = [CAGradientLayer layer];
    UIColor *color1= UIColorFromRGB(0x5CAFFF);
    UIColor *color2 = UIColorFromRGB(0x1252FF);
    //    UIColor *color1= [UIColor whiteColor];
    //    UIColor *color2 = [UIColor whiteColor];
    gradientLayer.colors = @[(__bridge id)color1.CGColor, (__bridge id)color2.CGColor];
    gradientLayer.startPoint = CGPointMake(0, 1);
    gradientLayer.endPoint = CGPointMake(0, 0);
    gradientLayer.frame = CGRectMake(frame.origin.x, frame.origin.y, SCREEN_WIDTH, frame.size.height);
    return gradientLayer;
}
+ (void)clearAllUserDefaultsData{
    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    NSDictionary *dic = [userDefault dictionaryRepresentation];
    for (id key in dic) {
        [userDefault removeObjectForKey:key];
    }
    [userDefault synchronize];
}

+ (void)clearUserDefaultsDataForKey:(NSString *)aKey{
    NSUserDefaults *userDefault = [NSUserDefaults standardUserDefaults];
    [userDefault removeObjectForKey:aKey];
    [userDefault synchronize];
}

+ (UIImage *)imageFromLayer:(CALayer *)layer
{
    UIGraphicsBeginImageContext([layer frame].size);
    [layer renderInContext:UIGraphicsGetCurrentContext()];
    UIImage *outputImage = UIGraphicsGetImageFromCurrentImageContext();
    
    UIGraphicsEndImageContext();
    
    return outputImage;
}


//返回异常信息
+ (void)showErrData:(NSData *)data{
    
    if (!data) {
        return;
    }
    [SCTools showErrorWithStatus:@"网络请求异常"];
}


//考试保存数据返回异常信息
+ (void)showExamSaveErrData:(NSData *)data{
    
    [SCTools showErrorWithStatus:@"网络请求异常"];
    
}
//考试提交数据返回异常信息
+ (void)showExamSubmitErrData:(NSData *)data{
    
    //    if (!data) {
    //        return;
    //    }
    
    [SCTools showErrorWithStatus:@"网络请求异常"];
}

//判断是否有emoji
//+ (NSString *)disable_emoji:(NSString *)text{
//    NSRegularExpression *regex = [NSRegularExpression regularExpressionWithPattern:@"[^\\u0020-\\u007E\\u00A0-\\u00BE\\u2E80-\\uA4CF\\uF900-\\uFAFF\\uFE30-\\uFE4F\\uFF00-\\uFFEF\\u0080-\\u009F\\u2000-\\u201f\r\n]"options:NSRegularExpressionCaseInsensitive error:nil];
//    NSString *modifiedString = [regex stringByReplacingMatchesInString:text
//                                                               options:0
//                                                                 range:NSMakeRange(0, [text length])
//                                                          withTemplate:@""];
//    return modifiedString;
//}
+ (BOOL )disable_emoji:(NSString *)text{
    
    if ([SCTools isNineKeyBoard:text] == YES) {
        return YES;
    }
    text = [text stringByReplacingOccurrencesOfString:@"…" withString:@"..."];
    text = [text stringByReplacingOccurrencesOfString:@"•" withString:@"·"];
    
    NSRegularExpression *regex = [NSRegularExpression regularExpressionWithPattern:@"[^\\u0020-\\u007E\\u00A0-\\u00BE\\u2E80-\\uA4CF\\uF900-\\uFAFF\\uFE30-\\uFE4F\\uFF00-\\uFFEF\\u0080-\\u009F\\u2000-\\u201f\r\n]"options:NSRegularExpressionCaseInsensitive error:nil];
    NSString *modifiedString = [regex stringByReplacingMatchesInString:text
                                                               options:0
                                                                 range:NSMakeRange(0, [text length])
                                                          withTemplate:@""];
    if ([text isEqualToString:modifiedString]) {
        return YES;
    }else{
        return NO;
    }
}

+ (BOOL)isNineKeyBoard:(NSString *)string
{
    NSString *other = @"➋➌➍➎➏➐➑➒";
    int len = (int)string.length;
    for(int i=0;i<len;i++)
    {
        if(!([other rangeOfString:string].location != NSNotFound))
            return NO;
    }
    return YES;
}

+ (BOOL)stringContrainsEmoji:(NSString *)string {
    //    __block BOOL returnValue = NO;
    //    [string enumerateSubstringsInRange:NSMakeRange(0, string.length) options:NSStringEnumerationByComposedCharacterSequences usingBlock:^(NSString * _Nullable substring, NSRange substringRange, NSRange enclosingRange, BOOL * _Nonnull stop) {
    //        const unichar hs = [substring characterAtIndex:0];
    //        if (0xd800 <= hs && hs <= 0xdbff) {
    //            if (substring.length > 1) {
    //                const unichar ls = [substring characterAtIndex:1];
    //                const int uc = ((hs - 0xd800) * 0x400) + (ls - 0xdc00) + 0x10000;
    //                if (0x1d000 <= uc && uc <= 0x1f77f) {
    //                    returnValue = YES;
    //                }
    //            }
    //        } else if (substring.length > 1) {
    //            const unichar ls = [substring characterAtIndex:1];
    //            if (ls == 0x20e3) {
    //                returnValue = YES;
    //            }
    //        } else {
    //            if (0x2100 <= hs && hs <= 0x27ff) {
    //                returnValue = YES;
    //            } else if (0x2B05 <= hs && hs <= 0x2b07) {
    //                returnValue = YES;
    //            } else if (0x2934 <= hs && hs <= 0x2935) {
    //                returnValue = YES;
    //            } else if (0x3297 <= hs && hs <= 0x3299) {
    //                returnValue = YES;
    //            } else if (hs == 0xa9 || hs == 0xae || hs == 0x303d || hs == 0x3030 || hs == 0x2b55 || hs == 0x2b1c || hs == 0x2b1b || hs == 0x2b50) {
    //                returnValue = YES;
    //            }
    //        }
    
    
    __block BOOL returnValue = NO;
    [string enumerateSubstringsInRange:NSMakeRange(0, [string length])
                               options:NSStringEnumerationByComposedCharacterSequences
                            usingBlock:^(NSString *substring, NSRange substringRange, NSRange enclosingRange, BOOL *stop) {
        if (substring.length > 0) {
            const unichar hs = [substring characterAtIndex:0];
            if (0x2194 <= hs && hs <= 0x2199) { returnValue = YES; }
            if (0x23e9 <= hs && hs <= 0x23fa) { returnValue = YES; }
            if (0x2600 <= hs && hs <= 0x2604) { returnValue = YES; }
            if (0x2648 <= hs && hs <= 0x2653) { returnValue = YES; }
            if (0x30 <= hs && hs <= 0x39)     { returnValue = YES; }
            if (0x26f0 <= hs && hs <= 0x26fd) { returnValue = YES; }
            if ( hs == 0x203c || hs == 0x2049 || hs == 0x2122 || hs == 0x2139 || hs == 0x21a9 || hs == 0x21aa || hs == 0x23 || hs == 0x231a || hs == 0x231b || hs == 0x2328 || hs == 0x23cf || hs == 0x24c2 || hs == 0x25b6 || hs == 0x25c0 || hs == 0x260e || hs == 0x2611 || hs == 0x2614 || hs == 0x2615 || hs == 0x2618 || hs == 0x261d || hs == 0x2620 || hs == 0x2622 || hs == 0x2623 || hs == 0x2626 || hs == 0x262a || hs == 0x262e || hs == 0x262f || hs == 0x2638 || hs == 0x2639 || hs == 0x263a || hs == 0x2668 || hs == 0x267b || hs == 0x267f || hs == 0x2692 || hs == 0x2693 || hs == 0x2694 || hs == 0x2696 || hs == 0x2697 || hs == 0x2699 || hs == 0x269b || hs == 0x269c || hs == 0x26a0 || hs == 0x26a1 || hs == 0x26b0 || hs == 0x26b1 || hs == 0x26bd || hs == 0x26be || hs == 0x26c4 || hs == 0x26c5 || hs == 0x26c8 || hs == 0x26ce || hs == 0x26cf || hs == 0x26d1 || hs == 0x26d3 || hs == 0x26d4 || hs == 0x26e9 || hs == 0x26ea || hs == 0x2702 || hs == 0x2705 || hs == 0x2708 || hs == 0x2709 || hs == 0x270a || hs == 0x270b || hs == 0x270c || hs == 0x270d || hs == 0x270f || hs == 0x2712 || hs == 0x2714 || hs == 0x2716 || hs == 0x271d || hs == 0x2721 || hs == 0x2728 || hs == 0x2733 || hs == 0x2734 || hs == 0x2744 || hs == 0x2747 || hs == 0x274c || hs == 0x274e || hs == 0x2753 || hs == 0x2754 || hs == 0x2755 || hs == 0x2757 || hs == 0x2763 || hs == 0x2764 || hs == 0x2795 || hs == 0x2796 || hs == 0x2797 || hs == 0x27a1 || hs == 0x27b0 || hs == 0x27bf || hs == 0x2934 || hs == 0x2935 || hs == 0x2b05 || hs == 0x2b06 || hs == 0x2b07 || hs == 0x2b50 || hs == 0x2b55 || hs == 0x3030 || hs == 0x303d || hs == 0x3297 || hs == 0x3299 || hs == 0x2a || hs == 0xa9 || hs == 0xae || hs == 0xd83c || hs == 0xd83d) { returnValue = YES; }
        }
    }];
    return returnValue;
    
}
// 文字自适应高度
+ (CGFloat)labelHeight:(UILabel *)label{
    // 保存文本文字大小
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:label.font,NSFontAttributeName, nil];
    CGSize sizes = CGSizeMake(label.frame.size.width, 10000);
    CGRect rect = [label.text boundingRectWithSize:sizes options:NSStringDrawingUsesLineFragmentOrigin attributes:dic context:nil];
    return rect.size.height;
}
+ (CGFloat)textFieldHeight:(UITextField *)tf{
    // 保存文本文字大小
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:tf.font,NSFontAttributeName, nil];
    CGSize sizes = CGSizeMake(tf.frame.size.width, 10000);
    CGRect rect = [tf.text boundingRectWithSize:sizes options:NSStringDrawingUsesLineFragmentOrigin attributes:dic context:nil];
    return rect.size.height;

}

// 文字自适应宽度
+ (CGFloat)labelWidth:(UILabel *)label{
    
    NSDictionary *dic = [NSDictionary dictionaryWithObjectsAndKeys:label.font,NSFontAttributeName, nil];
    CGSize sizes = CGSizeMake(10000, label.frame.size.height);
    CGRect rect = [label.text boundingRectWithSize:sizes options:NSStringDrawingUsesLineFragmentOrigin attributes:dic context:nil];
    return rect.size.width;
}


// 判断刘海屏，返回YES表示是刘海屏
+ (BOOL)isNotchScreen {
    
    if ([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad) {
        return NO;
    }
    
    CGSize size = [UIScreen mainScreen].bounds.size;
    NSInteger notchValue = size.width / size.height * 100;
    
    if (216 == notchValue || 46 == notchValue) {
        return YES;
    }
    
    return NO;
}

// 判断是否是刘海屏，返回刘海屏底部安全距离
+ (int)isNotchScreenInsetBottom{
    
    if ([UIDevice currentDevice].userInterfaceIdiom == UIUserInterfaceIdiomPad) {
        return 0;
    }
    
    CGSize size = [UIScreen mainScreen].bounds.size;
    NSInteger notchValue = size.width / size.height * 100;
    if (216 == notchValue || 46 == notchValue) {
        return 34;
    }
    
    return 0;
}

+ (NSString *)string2JSONString:(NSString *)string {
    NSMutableString *s = [NSMutableString stringWithString:string];
    [s replaceOccurrencesOfString:@"\"" withString:@"\\\"" options:NSCaseInsensitiveSearch range:NSMakeRange(0, [s length])];
    [s replaceOccurrencesOfString:@"/" withString:@"\\/" options:NSCaseInsensitiveSearch range:NSMakeRange(0, [s length])];
    [s replaceOccurrencesOfString:@"\n" withString:@"\\n" options:NSCaseInsensitiveSearch range:NSMakeRange(0, [s length])];
    [s replaceOccurrencesOfString:@"\b" withString:@"\\b" options:NSCaseInsensitiveSearch range:NSMakeRange(0, [s length])];
    [s replaceOccurrencesOfString:@"\f" withString:@"\\f" options:NSCaseInsensitiveSearch range:NSMakeRange(0, [s length])];
    [s replaceOccurrencesOfString:@"\r" withString:@"\\r" options:NSCaseInsensitiveSearch range:NSMakeRange(0, [s length])];
    [s replaceOccurrencesOfString:@"\t" withString:@"\\t" options:NSCaseInsensitiveSearch range:NSMakeRange(0, [s length])];
    return [NSString stringWithString:s];
}

+ (NSString *)toJsonStrWithArray:(NSArray *)arr {
    if ([arr isKindOfClass:[NSString class]]) {
        return (NSString *)arr;
    }
    NSError *parseError = nil;
    NSData *data = [NSJSONSerialization dataWithJSONObject:arr options:NSJSONWritingPrettyPrinted error:nil];
    NSString *jsonStr = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    jsonStr = [jsonStr stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceCharacterSet]];
    //    jsonStr = [jsonStr stringByReplacingOccurrencesOfString:@" " withString:@""];
    jsonStr = [jsonStr stringByReplacingOccurrencesOfString:@"\n" withString:@""];
    if (parseError) {
        jsonStr = @"";
    }
    return jsonStr;
}

#pragma mark 判断字符串是否为浮点数
+ (BOOL)isPureFloat:(NSString*)string{
    //    NSScanner* scan = [NSScanner scannerWithString:string];
    //    float val;
    //    return[scan scanFloat:&val] && [scan isAtEnd];
    
    return[string containsString:@"."];
}
#pragma mark --- 提取html字符串中的img标签url
+ (NSArray *)filterImageUrlFromHTML:(NSString *)html
{
    //    具体代码如下 返回的是这串字符串里面所有的图片地址 所有是一个集合
    
    NSMutableArray *resultArray = [NSMutableArray array];
    
    NSRegularExpression *regex = [NSRegularExpression regularExpressionWithPattern:@"<(img|IMG)(.*?)(/>|></img>|>)" options:NSRegularExpressionAllowCommentsAndWhitespace error:nil];
    NSArray *result = [regex matchesInString:html options:NSMatchingReportCompletion range:NSMakeRange(0, html.length)];
    
    for (NSTextCheckingResult *item in result) {
        NSString *imgHtml = [html substringWithRange:[item rangeAtIndex:0]];
        
        NSArray *tmpArray = nil;
        if ([imgHtml rangeOfString:@"src=\""].location != NSNotFound) {
            tmpArray = [imgHtml componentsSeparatedByString:@"src=\""];
        } else if ([imgHtml rangeOfString:@"src="].location != NSNotFound) {
            tmpArray = [imgHtml componentsSeparatedByString:@"src="];
        }
        
        if (tmpArray.count >= 2) {
            NSString *src = tmpArray[1];
            
            NSUInteger loc = [src rangeOfString:@"\""].location;
            if (loc != NSNotFound) {
                src = [src substringToIndex:loc];
                if (![src containsString:@".gif"]) {
                    [resultArray addObject:src];
                }
                //                [resultArray addObject:src];
            }
        }
    }
    
    return resultArray;
}
#pragma mark --- 提取html字符串中的img标签url
+ (NSString *)filterHTMLImage:(NSString *)str{
    NSScanner * scanner = [NSScanner scannerWithString:str];
    NSString * text = nil;
    while([scanner isAtEnd]==NO)
    {
        //找到标签的起始位置
        [scanner scanUpToString:@"<img" intoString:nil];
        //找到标签的结束位置
        [scanner scanUpToString:@">" intoString:&text];
        
        //        NSLog(@"scanner = %@",scanner);
        //        NSLog(@"text = %@",text);
        //        NSLog(@"str1 = %@",str);
        
        //替换字符
        
        if ([text containsString:@".gif"]) {
            
            str  = [str  stringByReplacingOccurrencesOfString:[NSString stringWithFormat:@"%@>",text] withString:@""];
            str  = [str  stringByReplacingOccurrencesOfString:@"\n" withString:@""];
        }else{
            
            str  = @"";
//            [str  stringByReplacingOccurrencesOfString:[NSString stringWithFormat:@"%@>",text] withString:kImageDataKey];
            
        }
        
        //        str  =  [str  stringByReplacingOccurrencesOfString:[NSString stringWithFormat:@"%@>",text] withString:@"|[图片]|"];
    }
    return str;
}
#pragma mark --- 过滤html字符串中的空格、换行符
+ (NSString *)filterHtmlMark:(NSString *)html{
    
    NSString*enspStr1 =@"&ensp;";
    html = [html stringByReplacingOccurrencesOfString:enspStr1 withString:@"  "];
    
    
    NSString*emspStr1 =@"&emsp;";
    html = [html stringByReplacingOccurrencesOfString:emspStr1 withString:@" "];
    
    NSString* regEx =@"&nbsp;";
    html = [html stringByReplacingOccurrencesOfString:regEx withString:@" "];
    
    NSString *amp= @"&amp;";
    html = [html stringByReplacingOccurrencesOfString:amp withString:@"&"];
    
    NSString *quot = @"&quot";
    html = [html stringByReplacingOccurrencesOfString:quot withString:@"\""];
    
    
    html = [html stringByReplacingOccurrencesOfString:@"&apos;" withString:@"'"];
    html = [html stringByReplacingOccurrencesOfString:@"&lt;" withString:@"<"];
    html = [html stringByReplacingOccurrencesOfString:@"&gt;" withString:@">"];
    
    //    NSString* dsf =@"动态图片";
    //    html = [html stringByReplacingOccurrencesOfString:dsf withString:@"1"];
    
    
    //    NSString* regEx1 =@"<br>";
    //
    //    html = [html stringByReplacingOccurrencesOfString:regEx1 withString:@"\n"];
    //
    //    NSString* regEx2 =@"<br/>";
    //
    //    html = [html stringByReplacingOccurrencesOfString:regEx2 withString:@"\n"];
    //
    //    NSString* regEx3 =@"</p>";
    //    html = [html stringByReplacingOccurrencesOfString:regEx3 withString:@"\n"];
    
    return html;
    
}
//指定宽度按比例缩放
+ (UIImage *) imageCompressForWidthScale:(UIImage *)sourceImage targetWidth:(CGFloat)defineWidth{
    
    UIImage *newImage = nil;
    CGSize imageSize = sourceImage.size;
    CGFloat width = imageSize.width;
    CGFloat height = imageSize.height;
    CGFloat targetWidth = defineWidth;
    CGFloat targetHeight = height / (width / targetWidth);
    CGSize size = CGSizeMake(targetWidth, targetHeight);
    CGFloat scaleFactor = 0.0;
    CGFloat scaledWidth = targetWidth;
    CGFloat scaledHeight = targetHeight;
    CGPoint thumbnailPoint = CGPointMake(0.0, 0.0);
    
    if(CGSizeEqualToSize(imageSize, size) == NO){
        
        CGFloat widthFactor = targetWidth / width;
        CGFloat heightFactor = targetHeight / height;
        
        if(widthFactor > heightFactor){
            scaleFactor = widthFactor;
        }
        else{
            scaleFactor = heightFactor;
        }
        scaledWidth = width * scaleFactor;
        scaledHeight = height * scaleFactor;
        
        if(widthFactor > heightFactor){
            
            thumbnailPoint.y = (targetHeight - scaledHeight) * 0.5;
            
        }else if(widthFactor < heightFactor){
            
            thumbnailPoint.x = (targetWidth - scaledWidth) * 0.5;
        }
    }
    
    UIGraphicsBeginImageContext(size);
    
    CGRect thumbnailRect = CGRectZero;
    thumbnailRect.origin = thumbnailPoint;
    thumbnailRect.size.width = scaledWidth;
    thumbnailRect.size.height = scaledHeight;
    
    [sourceImage drawInRect:thumbnailRect];
    
    newImage = UIGraphicsGetImageFromCurrentImageContext();
    
    if(newImage == nil){
        
        NSLog(@"scale image fail");
    }
    UIGraphicsEndImageContext();
    return newImage;
}

//强制转屏
+ (void)interfaceOrientation:(UIInterfaceOrientation)orientation
{
    if ([[UIDevice currentDevice] respondsToSelector:@selector(setOrientation:)]) {
        SEL selector  = NSSelectorFromString(@"setOrientation:");
        NSInvocation *invocation = [NSInvocation invocationWithMethodSignature:[UIDevice instanceMethodSignatureForSelector:selector]];
        [invocation setSelector:selector];
        [invocation setTarget:[UIDevice currentDevice]];
        int val = (int)orientation;
        // 从2开始是因为0 1 两个参数已经被selector和target占用
        [invocation setArgument:&val atIndex:2];
        [invocation invoke];
    }
}

//获取AVPlayer全屏幕播放时的视图控制器
+ (UIViewController *)getAVFullScreenViewController{
    
    NSArray *windows = [[UIApplication sharedApplication] windows];
    UIViewController *tempVC = nil;
    for (UIWindow *window in windows) {
        for (UIView *transitionView in window.subviews) {
            if ([transitionView isKindOfClass:NSClassFromString(@"UITransitionView")]) {
                for (UIView *subView in transitionView.subviews) {
                    id nextResponder = [subView nextResponder];
                    if ([nextResponder isKindOfClass:NSClassFromString(@"AVFullScreenViewController")]) {
                        tempVC = nextResponder;
                    }
                }
            }
        }
    }
    
    return tempVC;
}

#pragma mark - 当前时间戳（以毫秒为单位）
+ (NSString *)getNowTimeTimestamp{
    NSDate *datenow = [NSDate date];//现在时间,你可以输出来看下是什么格式
    NSString *timeSp = [NSString stringWithFormat:@"%ld", (long)([datenow timeIntervalSince1970]*1000)];
    return timeSp;
}


/**
 *  AES加密
 *
 *  @param plainText 明文
 *  @param key       密钥
 *  @param iv        向量
 *
 *  @return 密文
 */
#pragma mark - AES加密
+ (NSString *)AES128Encrypt:(NSString *)plainText key:(NSString *)key iv:(NSString *)iv {
    
    char keyPtr[kCCKeySizeAES256+1];
    memset(keyPtr, 0, sizeof(keyPtr));
    [key getCString:keyPtr maxLength:sizeof(keyPtr) encoding:NSUTF8StringEncoding];
    
    char ivPtr[kCCBlockSizeAES128 + 1];
    memset(ivPtr, 0, sizeof(ivPtr));
    [iv getCString:ivPtr maxLength:sizeof(ivPtr) encoding:NSUTF8StringEncoding];
    
    NSData* data = [plainText dataUsingEncoding:NSUTF8StringEncoding];
    
    size_t bufferSize = [data length] + kCCBlockSizeAES128;
    void *buffer = malloc(bufferSize);
    size_t numBytesEncrypted = 0;
    
    CCCryptorStatus cryptStatus = CCCrypt(kCCEncrypt,
                                          kCCAlgorithmAES128,
                                          kCCOptionPKCS7Padding,
                                          keyPtr,
                                          [key length],
                                          ivPtr,
                                          [data bytes],
                                          [data length],
                                          buffer,
                                          bufferSize,
                                          &numBytesEncrypted);
    if (cryptStatus == kCCSuccess) {
        NSData *resultData = [NSData dataWithBytesNoCopy:buffer length:numBytesEncrypted];
        return [resultData base64EncodedStringWithOptions:0];
    }
    free(buffer);
    return nil;
    
}
#pragma mark - 解密
+ (NSString *)AES128Decrypt:(NSString *)plainText key:(NSString *)key iv:(NSString *)iv{
    
    char keyPtr[kCCKeySizeAES256+1];
    memset(keyPtr, 0, sizeof(keyPtr));
    [key getCString:keyPtr maxLength:sizeof(keyPtr) encoding:NSUTF8StringEncoding];
    
    char ivPtr[kCCBlockSizeAES128 + 1];
    memset(ivPtr, 0, sizeof(ivPtr));
    [iv getCString:ivPtr maxLength:sizeof(ivPtr) encoding:NSUTF8StringEncoding];
    
    NSData* data = [plainText dataUsingEncoding:NSUTF8StringEncoding];
    
    size_t bufferSize = [data length] + kCCBlockSizeAES128;
    void *buffer = malloc(bufferSize);
    size_t numBytesEncrypted = 0;
    
    CCCryptorStatus cryptStatus = CCCrypt(kCCDecrypt,
                                          kCCAlgorithmAES128,
                                          kCCOptionPKCS7Padding,
                                          keyPtr,
                                          [key length],
                                          ivPtr,
                                          [data bytes],
                                          [data length],
                                          buffer,
                                          bufferSize,
                                          &numBytesEncrypted);
    if (cryptStatus == kCCSuccess) {
        NSData *resultData = [NSData dataWithBytesNoCopy:buffer length:numBytesEncrypted];
        return [[NSString alloc] initWithData:resultData encoding:NSUTF8StringEncoding];
    }
    free(buffer);
    return nil;
}


#pragma mark - DES加密
+ (NSString *) encryptUseDES:(NSString *)plainText {
    NSString *ciphertext = nil;
    NSData *textData = [plainText dataUsingEncoding:NSUTF8StringEncoding];
    NSUInteger dataLength = [textData length];
    unsigned char buffer[1024 * 5];
    memset(buffer, 0, sizeof(char));
    size_t numBytesEncrypted = 0;
    CCCryptorStatus cryptStatus = CCCrypt(kCCEncrypt, kCCAlgorithmDES,
                                          //                                          kCCOptionPKCS7Padding,
                                          kCCOptionPKCS7Padding|kCCOptionECBMode,
                                          //                                          [key UTF8String], kCCKeySizeDES,
                                          //                                          [iv UTF8String],
                                          [@"supports-center" UTF8String], kCCKeySizeDES,
                                          [@"" UTF8String],
                                          [textData bytes], dataLength,
                                          buffer, 1024,
                                          &numBytesEncrypted);
    if (cryptStatus == kCCSuccess) {
        NSData *data = [NSData dataWithBytes:buffer length:(NSUInteger)numBytesEncrypted];
        //        ciphertext = [data base64EncodedStringWithOptions:0];
        ciphertext = [self hexStringFromData:data];
    }
    return ciphertext;
}
#pragma mark - data转16进制字符串
+ (NSString *)hexStringFromData:(NSData *)data
{
    NSMutableString *str = [NSMutableString string];
    Byte *byte = (Byte *)[data bytes];
    for (int i = 0; i<[data length]; i++) {
        // byte+i为指针
        [str appendString:[self stringFromByte:*(byte+i)]];
    }
    return str;
}
+ (NSString *)stringFromByte:(Byte)byteVal
{
    NSMutableString *str = [NSMutableString string];
    
    //取高四位
    Byte byte1 = byteVal>>4;
    //取低四位
    Byte byte2 = byteVal & 0xf;
    //拼接16进制字符串
    [str appendFormat:@"%x",byte1];
    [str appendFormat:@"%x",byte2];
    return str;
}

#pragma mark - 身份证号校验
+ (BOOL)validateIDCardNumber:(NSString *)value
{
    value = [value stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
    
    int length = 0;
    
    if (!value) {
        return NO;
    }
    else {
        length = (int)value.length;
        
        if (length !=15 && length !=18) {
            return NO;
        }
    }
    // 省份代码
    NSArray *areasArray =@[@"11",@"12", @"13",@"14", @"15",@"21", @"22",@"23", @"31",@"32", @"33",@"34", @"35",@"36", @"37",@"41",@"42",@"43", @"44",@"45", @"46",@"50", @"51",@"52", @"53",@"54", @"61",@"62", @"63",@"64", @"65",@"71", @"81",@"82", @"91"];
    
    NSString *valueStart2 = [value substringToIndex:2];
    
    BOOL areaFlag =NO;
    
    for (NSString *areaCode in areasArray) {
        
        if ([areaCode isEqualToString:valueStart2]) {
            areaFlag =YES;
            break;
        }
    }
    
    if (!areaFlag) {
        return NO;
    }
    
    NSRegularExpression *regularExpression;
    NSUInteger numberofMatch;
    int year =0;
    switch (length) {
        case 15:{
            year = [value substringWithRange:NSMakeRange(6,2)].intValue +1900;
            if (year %4 ==0 || (year %100 ==0 && year %4 ==0)) {
                regularExpression = [[NSRegularExpression alloc]initWithPattern:@"^[1-9][0-9]{5}[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}$"
                                                                        options:NSRegularExpressionCaseInsensitive
                                                                          error:nil];//测试出生日期的合法性
            }else {
                regularExpression = [[NSRegularExpression alloc]initWithPattern:@"^[1-9][0-9]{5}[0-9]{2}((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}$"
                                                                        options:NSRegularExpressionCaseInsensitive
                                                                          error:nil];//测试出生日期的合法性
            }
            numberofMatch = [regularExpression numberOfMatchesInString:value
                                                               options:NSMatchingReportProgress
                                                                 range:NSMakeRange(0, value.length)];
            
            if(numberofMatch >0) {
                
                return YES;
            }else {
                return NO;
            }
        }
        case 18:
            year = [value substringWithRange:NSMakeRange(6,4)].intValue;
            if (year %4 ==0 || (year %100 ==0 && year %4 ==0)) {
                regularExpression = [[NSRegularExpression alloc]initWithPattern:@"^[1-9][0-9]{5}((19[0-9]{2})|(2[0-9]{3}))((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|[1-2][0-9]))[0-9]{3}[0-9Xx]$"
                                                                        options:NSRegularExpressionCaseInsensitive
                                                                          error:nil];//测试出生日期的合法性
            }else {
                regularExpression = [[NSRegularExpression alloc]initWithPattern:@"^[1-9][0-9]{5}((19[0-9]{2})|(2[0-9]{3}))((01|03|05|07|08|10|12)(0[1-9]|[1-2][0-9]|3[0-1])|(04|06|09|11)(0[1-9]|[1-2][0-9]|30)|02(0[1-9]|1[0-9]|2[0-8]))[0-9]{3}[0-9Xx]$"
                                                                        options:NSRegularExpressionCaseInsensitive
                                                                          error:nil];//测试出生日期的合法性
            }
            numberofMatch = [regularExpression numberOfMatchesInString:value
                                                               options:NSMatchingReportProgress
                                                                 range:NSMakeRange(0, value.length)];
            
            if(numberofMatch >0) {
                
                int S = ([value substringWithRange:NSMakeRange(0,1)].intValue + [value substringWithRange:NSMakeRange(10,1)].intValue) *7 + ([value substringWithRange:NSMakeRange(1,1)].intValue + [value substringWithRange:NSMakeRange(11,1)].intValue) *9 + ([value substringWithRange:NSMakeRange(2,1)].intValue + [value substringWithRange:NSMakeRange(12,1)].intValue) *10 + ([value substringWithRange:NSMakeRange(3,1)].intValue + [value substringWithRange:NSMakeRange(13,1)].intValue) *5 + ([value substringWithRange:NSMakeRange(4,1)].intValue + [value substringWithRange:NSMakeRange(14,1)].intValue) *8 + ([value substringWithRange:NSMakeRange(5,1)].intValue + [value substringWithRange:NSMakeRange(15,1)].intValue) *4 + ([value substringWithRange:NSMakeRange(6,1)].intValue + [value substringWithRange:NSMakeRange(16,1)].intValue) *2 + [value substringWithRange:NSMakeRange(7,1)].intValue *1 + [value substringWithRange:NSMakeRange(8,1)].intValue *6 + [value substringWithRange:NSMakeRange(9,1)].intValue *3;
                
                int Y = S %11;
                
                NSString *M =@"F";
                
                NSString *JYM =@"10X98765432";
                
                M = [JYM substringWithRange:NSMakeRange(Y,1)];// 判断校验位
                
                if ([M isEqualToString:[value substringWithRange:NSMakeRange(17,1)]]) {
                    return YES;// 检测ID的校验位
                }else {
                    return NO;
                }
            }else {
                
                return NO;
            }
        default:
            return NO;
    }
}

//根据身份证号码转换成生日
+ (NSString *)birthdayStrFromIdentityCard:(NSString *)numberStr{
    NSMutableString *result = [NSMutableString stringWithCapacity:0];
    NSString *year = nil;
    NSString *month = nil;
    BOOL isAllNumber = YES;
    NSString *day = nil;
    if([numberStr length]<14)
        return result;
    if (numberStr.length == 18) {
        //**截取前14位
        NSString *fontNumer = [numberStr substringWithRange:NSMakeRange(0, 13)];
        //**检测前14位否全都是数字;
        const char *str = [fontNumer UTF8String];
        const char *p = str;
        while (*p!='\0') {
            if(!(*p>='0'&&*p<='9'))
                isAllNumber = NO;
            p++;
        }
        if(!isAllNumber)
            return result;
        year = [numberStr substringWithRange:NSMakeRange(6, 4)];
        month = [numberStr substringWithRange:NSMakeRange(10, 2)];
        day = [numberStr substringWithRange:NSMakeRange(12,2)];
        
        [result appendString:year];
        [result appendString:@"-"];
        [result appendString:month];
        [result appendString:@"-"];
        [result appendString:day];
        return result;
    }else{
        NSString *fontNumer = [numberStr substringWithRange:NSMakeRange(0, 11)];
        //**检测前14位否全都是数字;
        const char *str = [fontNumer UTF8String];
        const char *p = str;
        while (*p!='\0') {
            if(!(*p>='0'&&*p<='9'))
                isAllNumber = NO;
            p++;
        }
        if(!isAllNumber)
            return result;
        year = [numberStr substringWithRange:NSMakeRange(6, 2)];
        month = [numberStr substringWithRange:NSMakeRange(8, 2)];
        day = [numberStr substringWithRange:NSMakeRange(10,2)];
        NSString* resultAll = [NSString stringWithFormat:@"19%@-%@-%@",year,month,day];
        return resultAll;
    }
}

//获取当前年份
+ (NSString *)getCurrentYear
{
    NSDateFormatter *date_formatter = [[NSDateFormatter alloc] init];
    [date_formatter setDateFormat:@"yyyy"];
    NSString *current_date_str = [date_formatter stringFromDate:[NSDate date]];
    return current_date_str;
}

#pragma mark - 判断是否是山西项目
+ (BOOL )isShanXiProjectID{
    NSArray *array = [NSArray arrayWithObjects:@"397971547243126784",@"397971404544516096",@"397971264481988608",@"397970876158681088",@"397969709145985024",@"397968570667212800",@"398965215164678144",@"399038066038415360", @"400435505214025728",@"399687450418155520",@"399042507881848832", nil];
    BOOL isbool = false;//[array containsObject:UserProjectId];
    return isbool;
}


#pragma mark ……Yvan…… 保留一位小数
+ (NSNumber *)formatValue:(NSString *)value {
    if (IsStrEmpty(value)) {
        return @0;
    } else {
        return @([NSString stringWithFormat:@"%.1f", value.floatValue].floatValue);
    }
}

@end
