//
//  GSChatView.m
//  RtSDKDemo
//
//  Created by Sheng on 2017/11/13.
//  Copyright © 2017年 gensee. All rights reserved.
//

#import "GSChatView.h"
#import "UIView+GSSetRect.h"
#import "GSFaceView.h"
#import <GSCommonKit/GSChatContentParse.h>
#import "GSChatModel.h"
#import "YBPopupMenu.h"
#import "JustmeView.h"
#import "GSChatViewXTXXCell.h"
#import "PrefixHeader.pch"
#pragma mark - tableView gategory

@implementation UITableView (scrollBottom)

- (void)scrollToBottom:(BOOL)animated{
    NSUInteger rows = [self numberOfRowsInSection:0];
    if (rows > 0 && (self.contentSize.height > self.bounds.size.height)) {
        [self scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:rows - 1 inSection:0] atScrollPosition:UITableViewScrollPositionBottom animated:animated];
    }
}

@end

#define Keyboard_H 49

@interface GSChatView () <UITableViewDelegate,UITableViewDataSource, GSChatToolbarDelegate,YBPopupMenuDelegate>

@property (nonatomic, strong) UITableView *tableView;
@property(nonatomic,strong)JustmeView *justmeView;
@property (nonatomic, strong) GSFaceView *faceView;
@property (nonatomic, assign) BOOL Islongshow; //只显示我
/**
 *  聊天所使用的ID
 */
@property (assign, nonatomic)unsigned chatID;
/**
 *  接收消息的用户的昵称
 */
@property (nonatomic, copy) NSString *targetUserName;

@end

@implementation GSChatView
{
    BOOL isSetupViews;
    BOOL bottomflag; //tableView是否处于底部
}
- (instancetype)initWithFrame:(CGRect)frame
{
    if (self = [super initWithFrame:frame]) {
        self.Islongshow = NO;
        self.chatID = 0;
        [self loadContent];
    }
    return self;
}


#pragma mark - public

- (void)refresh{
    
    if (_dataModelArray.count == 0) {
        return;
    }
    
    [self.tableView reloadData];
    
    if (self.tableView.contentSize.height > self.tableView.frame.size.height) {
        NSUInteger rows = [self.tableView numberOfRowsInSection:0];
        
        [self.tableView scrollToRowAtIndexPath:[NSIndexPath indexPathForRow:rows - 1 inSection:0] atScrollPosition:UITableViewScrollPositionBottom animated:YES];
    }
    
}

- (void)onDoubleTeacherStatusChange
{
    [self.dataModelArray removeAllObjects];
    [self.tableView reloadData];
}
- (void)insertuserinfo:(GSPUserInfo*)userinfo
{
    BOOL isexistence = false;
    GSPUserInfo* selfuserinfo =  [GSPPlayerManager sharedManager].selfUserInfo;
    if (selfuserinfo.userID == userinfo.userID)
    {
        isexistence = true;
    }
    for (GSPUserInfo *info in self.userInfoArray)
    {
        if (info.userID == userinfo.userID)
        {
            isexistence = true;
        }
    }
    if (!isexistence)
    {
        
        [self.userInfoArray addObject:userinfo];
    }
}
- (void)removeuserinfo:(GSPUserInfo *)userinfo
{
    if ([self.userInfoArray containsObject:userinfo] )
    {
        for (int i=0; i<self.userInfoArray.count; i++) {
               
                if (self.userInfoArray[i] == userinfo) {
                    [self.userInfoArray removeObjectAtIndex:i];
                    i--;
                }
            }
    }
}
//插入数据 并插入cell
- (void)insert:(GSChatModel*)model{
    [self insert:model forceBottom:NO];
}

- (void)insert:(GSChatModel*)model forceBottom:(BOOL)isBottom{
    

    
    if (self.dataModelArray.count > 200) {
        [self.dataModelArray removeObjectAtIndex:0];
    }
    if (self.Islongshow)
    {
        GSPUserInfo *user = [GSPPlayerManager sharedManager].selfUserInfo;
        
        if (model.chatMessage.senderUserID == user.userID) {
            model.Isshow = YES;
        }else
        {
            model.Isshow = NO;
        }
        
    }else
    {
    model.Isshow = YES;
    }
    [self.dataModelArray addObject:model];
    
    [self.tableView reloadData];
    
    if ((!bottomflag) && !isBottom ) {
        
        //这里应该是未读消息提示操作
        
    }else{
        [self.tableView scrollToBottom:NO];
        
    }
 
}

- (void)removeByUser:(NSString *)userID{
    NSMutableArray *removeArr = [NSMutableArray array];
    for (GSChatModel *model in self.dataModelArray) {
        if (model.chatMessage.senderUserID == userID.longLongValue) {
            [removeArr addObject:model];
        }
    }
    
    [self.dataModelArray removeObjectsInArray:removeArr];


    
    if (!self.tableView.hidden) {
        [self.tableView reloadData];
    }

}
- (void)removeByMessage:(NSString *)messageID{
    
    GSChatModel *deleteModel;
    
    for (GSChatModel *model in self.dataModelArray) {
        if ([model.chatMessage.msgID isEqualToString:messageID]) {
            deleteModel = model;
            break;
        }
    }
    
    [self.dataModelArray removeObject:deleteModel];
    

    if (!self.tableView.hidden) {
        [self.tableView reloadData];
    }

    
}

static NSString *modelCellFlag = @"GSChatViewCell.h";

-(void)justBtnClickAction
{
    self.Islongshow = !self.Islongshow;
    if (self.Islongshow)
    {
        _justmeView.JustLabel.textColor = [UIColor whiteColor];
        _justmeView.bgview.backgroundColor = [UIColor colorWithRed:183/255.0 green:52/255.0 blue:46/255.0 alpha:1.0];
        [self didShowMyMessage:YES];
        [_justmeView.justBtn setImage:[UIImage imageNamed:@"change_icon"] forState:UIControlStateNormal];
    }else
    {
        [_justmeView.justBtn setImage:[UIImage imageNamed:@"unchange_icon"] forState:UIControlStateNormal];
        _justmeView.JustLabel.textColor = HEXCOLOR(0x666666);
        _justmeView.bgview.backgroundColor = [UIColor whiteColor];
        [self didShowMyMessage:NO];
        
    }
}
- (void)loadContent{
    
    _justmeView = [[[NSBundle bundleWithPath:@"/Users/cooper/Desktop/gensee_plugin/ios/Classes/Farmwork/live/JustmeView.xib"] loadNibNamed:NSStringFromClass([JustmeView class]) owner:self options:nil] lastObject];
    _justmeView.frame = CGRectMake(0, 0, self.frame.size.width, 40);
    _justmeView.justBtn.selected = false;
    [_justmeView.justBtn setTitle:@"" forState:UIControlStateNormal];
    [_justmeView.justBtn setImage:[UIImage imageNamed:@"unchange_icon"] forState:UIControlStateNormal];
    // 添加点击手势
    UITapGestureRecognizer *tapGesture = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(justBtnClickAction)];
    [_justmeView.bgview addGestureRecognizer:tapGesture];
    [_justmeView.justBtn addTarget:self action:@selector(justBtnClickAction) forControlEvents:UIControlEventTouchUpInside];
    [self addSubview:_justmeView];
    _tableView = [[UITableView alloc] initWithFrame:CGRectMake(0, 40, self.frame.size.width, self.frame.size.height - Keyboard_H - 60) style:UITableViewStylePlain];
    _tableView.delegate=self;
    _tableView.dataSource=self;
    _tableView.separatorStyle = UITableViewCellSeparatorStyleSingleLine;
    if ([self.tableView respondsToSelector:@selector(setSeparatorInset:)])
    {[self.tableView setSeparatorInset:UIEdgeInsetsMake(0, 10, 0, 10)]; }
    [self.tableView setSeparatorColor:HEXCOLOR(0xEEEEEE)];
    [self _setExtraCellLineHidden:_tableView];

    self.chatToolbar = [[GSChatToolBar alloc]initWithFrame:CGRectMake(0, self.frame.size.height - Keyboard_H - 10 , self.frame.size.width, Keyboard_H)];
    self.chatToolbar.delegate = self;

    [self addSubview:_chatToolbar];

    
    //Initializa the gesture recognizer
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(keyBoardHidden:)];
    [self addGestureRecognizer:tap];
    
    [_tableView registerClass:[GSChatViewCell class] forCellReuseIdentifier:modelCellFlag];
    [_tableView registerNib:[UINib nibWithNibName:NSStringFromClass([GSChatViewXTXXCell class]) bundle:nil] forCellReuseIdentifier:NSStringFromClass([GSChatViewXTXXCell class])];
    [self addSubview:_tableView];
    
    isSetupViews = YES;
    bottomflag = YES;
    [self setupEmotion];
}

- (void)setupEmotion
{
    NSArray *emotions = [[GSChatContentParse sharedInstance] allEmotions];
    
    GSBaseEmotion *emotion = [emotions objectAtIndex:0];
    GSEmotionManager *manager= [[GSEmotionManager alloc] initWithEmotionRow:3 emotionCol:6 emotions:emotions tagImage:[UIImage imageNamed:emotion.emotionLocal]];
    [self.faceView setEmotionManagers:@[manager]];
    
}
- (void)setChatToolbar:(GSChatToolBar *)chatToolbar
{
    [_chatToolbar removeFromSuperview];
    
    _chatToolbar = chatToolbar;
    if (_chatToolbar) {
        [self addSubview:_chatToolbar];
    }
    
    CGRect tableFrame = self.tableView.frame;
    tableFrame.size.height = self.frame.size.height - _chatToolbar.frame.size.height - 20 - 40;
    self.tableView.frame = tableFrame;
    if ([chatToolbar isKindOfClass:[GSChatToolBar class]]) {
        [(GSChatToolBar *)self.chatToolbar setDelegate:self];
        self.faceView = (GSFaceView*)[(GSChatToolBar *)self.chatToolbar faceView];
    }
}


-(void)keyBoardHidden:(UITapGestureRecognizer *)tapRecognizer
{
    if (tapRecognizer.state == UIGestureRecognizerStateEnded) {
        [self.chatToolbar endEditing:YES];
    }
}
-(void)endEditing
{
    [self.chatToolbar endEditing:YES];
}
- (NSMutableArray *)dataModelArray
{
    if (!_dataModelArray) {
        _dataModelArray = [NSMutableArray array];
    }
    return _dataModelArray;
}
- (NSMutableArray *)userInfoArray
{
    if (!_userInfoArray) {
        _userInfoArray = [NSMutableArray array];
    }
    return _userInfoArray;
}

-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    
    return self.dataModelArray.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
//    cell.selectionStyle = UITableViewCellSelectionStyleNone;
    GSChatModel *model = self.dataModelArray[indexPath.row];
    if (model.chatMessage.chatType == GSPChatTypeSystem)
    {
        GSChatViewXTXXCell * cell= (GSChatViewXTXXCell *)[tableView dequeueReusableCellWithIdentifier:NSStringFromClass([GSChatViewXTXXCell class])];
        if (!cell) {
            cell=[[GSChatViewXTXXCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:NSStringFromClass([GSChatViewXTXXCell class])];
        }
        cell.closeBtn.tag = indexPath.row;
        [cell refreshCellWithGSChatModel:model];
        [cell.closeBtn addTarget:self action:@selector(closeBtnAction:) forControlEvents:UIControlEventTouchUpInside];
        return cell;
    }else
    {
        GSChatViewCell *cell  = [tableView dequeueReusableCellWithIdentifier:modelCellFlag];
        [cell setModel:self.dataModelArray[indexPath.row]];
        return cell;
    }
  
    
  
}

-(void)closeBtnAction:(UIButton *)sender
{
    
    GSChatModel *model = self.dataModelArray[sender.tag];
    [self removeByMessage:model.chatMessage.msgID];
}
- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
    GSChatModel *model1 = self.dataModelArray[indexPath.row];
    GSBaseModel *model = self.dataModelArray[indexPath.row];
//    NSLog(@"row :%d, height:%f",(int)indexPath.row,model.totalHeight);
    if (model1.Isshow)
    {
        if (model1.chatMessage.chatType == GSPChatTypeSystem)
        {
            return  67;
        }else
        {
        return 10 + model.totalHeight;
        }
    }else
    {
        return  0.1;
    }
   
}
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    GSChatModel *model1 = self.dataModelArray[indexPath.row];
}

- (BOOL)judgeIsOnBottom
{
    CGFloat height = self.tableView.frame.size.height;
    CGFloat contentOffsetY = self.tableView.contentOffset.y;
    CGFloat bottomOffset = self.tableView.contentSize.height - contentOffsetY;
    
//    NSLog(@"sizeH:%f,H:%f,Y:%f",self.tableView.contentSize.height,self.tableView.frame.size.height,contentOffsetY);
    
    if (bottomOffset <= height)
    {
        //在最底部
        return  YES;
    }
    else
    {
        return  NO;
    }
}

- (void)scrollViewDidScroll:(UIScrollView *)scrollView
{
    
    CGFloat MAX_RANGE = 20; //是手指拖动的最大误差范围
    
    if (scrollView == self.tableView) {
        bottomflag = ((self.tableView.contentSize.height - self.tableView.contentOffset.y) - MAX_RANGE)  <= self.tableView.frame.size.height;
    }
}

#pragma mark - Utilities
-(void)_setExtraCellLineHidden:(UITableView *)tableView {
    UIView *view = [UIView new];
    view.backgroundColor = [UIColor clearColor];
    [tableView setTableFooterView:view];
}


#pragma mark - EMChatToolbarDelegate

- (void)chatToolbarDidChangeFrameToHeight:(CGFloat)toHeight
{
    CGRect rect = self.tableView.frame;
    rect.origin.y = 40;
    rect.size.height = self.frame.size.height - toHeight - 10 - 40;
    if (rect.size.height <= 0)
    {
        rect.size.height = 0;
    }
    self.tableView.frame = rect;
    [self.tableView reloadData];
    
    [self.tableView scrollToBottom:YES];
}

- (void)inputTextViewWillBeginEditing:(GSTextView *)inputTextView
{
//    if (_menuController == nil) {
//        _menuController = [UIMenuController sharedMenuController];
//    }
//    [_menuController setMenuItems:nil];
}
-(void)didShowMyMessage:(BOOL)isShow
{
    if (isShow)
    {
        
        GSPUserInfo *user = [GSPPlayerManager sharedManager].selfUserInfo;
        for (GSChatModel *model in self.dataModelArray) {
            if (model.chatMessage.senderUserID == user.userID) {
                model.Isshow = YES;
            }else
            {
                model.Isshow = NO;
            }
        }
        [self.tableView reloadData];
    }else
    {
       
        for (GSChatModel *model in self.dataModelArray) {
            model.Isshow = YES;
        }
        [self.tableView reloadData];
    }
}
-(void)didmore:(UIButton *)sender
{
    NSMutableArray *TITLES = [NSMutableArray array];
    [TITLES addObject:@"所有人"];
    for (GSPUserInfo* userinfo in self.userInfoArray) {

        [TITLES addObject:userinfo.userName];
        }
    [YBPopupMenu showRelyOnView:sender titles:TITLES icons:nil menuWidth:100 otherSettings:^(YBPopupMenu *popupMenu) {
        popupMenu.delegate = self;
       
    }];
}
#pragma mark - YBPopupMenuDelegate
//     openLive_arrow_down
- (void)ybPopupMenuDidDismiss:(YBPopupMenu *)ybPopupMenu
     {
         self.chatToolbar.ReceiverImageView.image = [UIImage imageNamed:@"tool_down_icon"];
//        [self.chatToolbar.ReceiverButton setImage:[UIImage imageNamed:@"openLive_arrow_down"] forState:UIControlStateNormal];
}
- (void)ybPopupMenu:(YBPopupMenu *)ybPopupMenu didSelectedAtIndex:(NSInteger)index
     {
        //    self.chatID
        NSString * title = ybPopupMenu.titles[index];
        if([title isEqualToString:@"所有人"])
        {
            self.chatID = 0;
            self.targetUserName = title;
        }else
        {
            for (GSPUserInfo* userinfo in self.userInfoArray) {
                if (userinfo.userName == title)
                {
                    
                    self.chatID = userinfo.chatID;
                    
                    self.targetUserName = userinfo.userName;
                }
                
            }
        }
//        [self.chatToolbar setReceiverButtonTitle:title];
        [self.chatToolbar.ReceiverButton setTitle:title forState:UIControlStateNormal];
        //推荐回调
        NSLog(@"点击了 %@ 选项",ybPopupMenu.titles[index]);
}
- (void)didSendText:(NSString *)text
{
   
    if (text && text.length > 0) {
        
        NSString *normalText = [[GSPPlayerManager sharedManager] textFilter:text];
        
        NSString *html = [[GSChatContentParse sharedInstance] htmlFromEmotionText:normalText];
        
        GSPUserInfo *user = [GSPPlayerManager sharedManager].selfUserInfo;
        
        GSPChatMessage *chatMessage = [GSPChatMessage new];
        chatMessage.text = normalText;
        chatMessage.richText = html;
        chatMessage.msgID = [[NSUUID UUID] UUIDString];
        chatMessage.senderName = user.userName;
        chatMessage.senderUserID = user.userID;
        chatMessage.senderName = user.userName;
        chatMessage.chatType = GSPChatTypePublic;
        chatMessage.receiveTime = [[NSDate date] timeIntervalSince1970];
        
        if (self.chatID == 0)
        {
            GSChatModel *model = [[GSChatModel alloc]initWithModel:chatMessage type:GSChatModelPublic];

            [self insert:model forceBottom:YES];
        [[GSPPlayerManager sharedManager] chatWithAll:chatMessage];
            
        }else
        {
            chatMessage.targetUserName = self.targetUserName;
            GSChatModel *model = [[GSChatModel alloc]initWithModel:chatMessage type:GSChatModelPrivate2];

            [self insert:model forceBottom:YES];
            [[GSPPlayerManager sharedManager] chatWithUser:self.chatID message:chatMessage];
//            self.chatID = 0;
//            self.targetUserName = @"";
        }
        
        NSLog(@"text:%@,html:%@",normalText,html);
    }
}

@end
