//
//  SCHttpTool.h
//  StudyCommune
//
//  Created by tech on 15/12/3.
//  Copyright © 2015年 tech. All rights reserved.

//  网络请求工具类：负责整个项目的所有HTTP请求

#import <Foundation/Foundation.h>

@interface SCHttpTool : NSObject

/**
 *  发送一个GET请求
 *
 *  @param url     请求路径
 *  @param params  请求参数model
 *  @param success 请求成功后的回调
 *  @param failure 请求失败后的回调
 */
+ (void)get:(NSString *)url params:(id)params success:(void (^)(id responseObj))success failure:(void (^)(NSError *error))failure;
/**
 *  发送一个POST请求
 *
 *  @param url     请求路径
 *  @param params  请求参数model
 *  @param success 请求成功后的回调
 *  @param failure 请求失败后的回调
 */
+ (void)post:(NSString *)url params:(id)params success:(void (^)(id responseObj))success failure:(void (^)(NSError *error))failure;



/**
 *  发送一个GET请求  (带token值)
 *
 *  @param url     请求路径
 *  @param token   token值
 *  @param params  请求参数model
 *  @param success 请求成功后的回调
 *  @param failure 请求失败后的回调
 */
+ (void)get:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id responseObj))success failure:(void (^)(NSError *error))failure;

/**
 *  发送一个POST请求  (带token值)
 *
 *  @param url     请求路径
 *  @param token   token值
 *  @param params  请求参数model
 *  @param success 请求成功后的回调
 *  @param failure 请求失败后的回调
 */
+ (void)post:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id responseObj))success failure:(void (^)(NSError *error))failure;

/**
 *  发送一个GETCACHE请求
 *
 *  @param url     请求路径
 *  @param params  请求参数model
 *  @param success 请求成功后的回调
 *  @param failure 请求失败后的回调
 *  @param caches  请求缓存后的回调
 */
+ (void)getCache:(NSString *)url params:(id)params success:(void (^)(id responseObj))success failure:(void (^)(NSError *error))failure caches:(void(^)(id object))caches;



/**
*  发送一个POST请求 网院APP-登录授权接口
*
*  @param url     请求路径
*  @param params  请求参数model
*  @param success 请求成功后的回调
*  @param failure 请求失败后的回调
*/
+ (void)postAuthorizedLogin:(NSString *)url params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;
+ (void)getAuthorizedLogin:(NSString *)url params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;

+ (void)post:(NSString *)url paramsDic:(NSDictionary *)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;

//学习公社云接口
+ (void)xxapiGet:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;
+ (void)xxapiGet:(NSString *)url token:(NSString *)token rootSelId:(NSString *)rootSelId params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;
+ (void)xxapiPost:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;
+ (void)xxapiPost:(NSString *)url token:(NSString *)token rootSelId:(NSString *)rootSelId  params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;
+ (void)xxapiDELETE:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;

+ (void)xxapiImagePost:(NSString *)url  imageFileName:(NSString *)imageFileName  imgData:(NSData *)imgData token:(NSString *)token rootSelId:(NSString *)rootSelId  params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure;


+ (void)checkNetworkStatus;

@end
