//
//  SCHttpTool.m
//  StudyCommune
//
//  Created by tech on 15/12/3.
//  Copyright © 2015年 tech. All rights reserved.
//

#import "SCHttpTool.h"
#import "AFNetworking.h"
#import "MJExtension.h"
#import "Reachability.h"
#import "PINCache.h"
#import "PrefixHeader.pch"
@implementation SCHttpTool

+ (void)get:(NSString *)url params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    [sessionManager.requestSerializer setValue:Grtapp forHTTPHeaderField:@"User-Agent"];
    /*
    // 客户端是否信任非法证书
    sessionManager.securityPolicy.allowInvalidCertificates = YES;
    // 是否在证书域字段中验证域名
    [sessionManager.securityPolicy setValidatesDomainName:NO];
     */
    sessionManager.requestSerializer.timeoutInterval = 10;
    ///金隅 机关 国教传orgId
#if JinYu || JiGuan || GuoQingJiaoYu
    [sessionManager.requestSerializer setValue:ORGID forHTTPHeaderField: @"orgId"];
#else
    [sessionManager.requestSerializer setValue:IndustryIdH5 forHTTPHeaderField: @"u-industryId"];
#endif
   
    
    [sessionManager GET:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        if (failure) {
            //            [SCTools showErrorWithStatus:@"加载失败"];
            [SCHttpTool showNetworkError];
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
        
    }];
    
}


+ (void)post:(NSString *)url params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.responseSerializer.acceptableContentTypes = nil;
    [sessionManager.requestSerializer setValue:Grtapp forHTTPHeaderField:@"User-Agent"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    ///金隅 机关 国教传orgId
#if JinYu || JiGuan || GuoQingJiaoYu
    [sessionManager.requestSerializer setValue:ORGID forHTTPHeaderField: @"orgId"];
#else
    [sessionManager.requestSerializer setValue:IndustryIdH5 forHTTPHeaderField: @"u-industryId"];
#endif
  
    
    [sessionManager POST:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        if (failure) {
            //            [SCTools showErrorWithStatus:@"加载失败"];
            [SCHttpTool showNetworkError];
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
    
}



+ (void)get:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    
    NSDictionary *dicParams = [params mj_keyValues];
    
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.responseSerializer.acceptableContentTypes = nil;
    [sessionManager.requestSerializer setValue:Grtapp forHTTPHeaderField:@"User-Agent"];
    [sessionManager.requestSerializer setValue:token forHTTPHeaderField:@"u-token"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    ///金隅 机关 国教传orgId
#if JinYu || JiGuan || GuoQingJiaoYu
    [sessionManager.requestSerializer setValue:ORGID forHTTPHeaderField: @"orgId"];
#else
    [sessionManager.requestSerializer setValue:IndustryIdH5 forHTTPHeaderField: @"u-industryId"];
#endif
    [sessionManager GET:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        if (failure) {
            NSLog(@"error = %@",error);
            
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
        
    }];
}

+ (void)post:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    NSDictionary *dicParams = [params mj_keyValues];
    
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    [sessionManager.requestSerializer setValue:Grtapp forHTTPHeaderField:@"User-Agent"];
    [sessionManager.requestSerializer setValue:token forHTTPHeaderField:@"u-token"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    ///金隅 机关 国教传orgId
#if JinYu || JiGuan || GuoQingJiaoYu
    [sessionManager.requestSerializer setValue:ORGID forHTTPHeaderField: @"orgId"];
#else
    [sessionManager.requestSerializer setValue:IndustryIdH5 forHTTPHeaderField: @"u-industryId"];
#endif
    
    [sessionManager POST:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        if (failure) {
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
}


+ (void)getCache:(NSString *)url params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure caches:(void(^)(id object))caches{
    
    //核查网络状况
    Reachability *reach = [Reachability reachabilityForInternetConnection];
    NetworkStatus status = [reach currentReachabilityStatus];
    if (status == NotReachable) {
        
        [SCTools showErrorWithStatus:@"网络异常"];
        
        [[PINCache sharedCache] objectForKey:url block:^(PINCache * _Nonnull cache, NSString * _Nonnull key, id  _Nullable object) {
            dispatch_async(dispatch_get_main_queue(), ^{
                
                if (caches) {
                    caches(object);
                }
            });
        }];
        return;
    }
    
    if (status == ReachableViaWiFi || status == ReachableViaWWAN) {
        //清除缓存
        [[PINCache sharedCache] removeObjectForKey:url];
        [self get:url params:params success:^(id responseObj) {
            if (success) {
                success(responseObj);
                //添加对应url 的缓存
                [[PINCache sharedCache] setObject:responseObj forKey:url];
            }
            
        } failure:^(NSError *error) {
            
            if (failure) {
                failure(error);
            }
        }];
    }
    
}
/**
 *  发送一个POST请求 网院APP-登录授权接口
 *
 *  @param url     请求路径
 *  @param params  请求参数model
 *  @param success 请求成功后的回调
 *  @param failure 请求失败后的回调
 */
+ (void)postAuthorizedLogin:(NSString *)url params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.responseSerializer.acceptableContentTypes = nil;
    [sessionManager.requestSerializer setValue:@"ableskyapp,ios" forHTTPHeaderField:@"User-Agent"];
    [sessionManager.requestSerializer  setValue:@"http://studyapp.enaea.edu.cn/login.do" forHTTPHeaderField:@"Referer"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager POST:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        
        if (failure) {
            //            [SCTools showErrorWithStatus:@"加载失败"];
            [SCHttpTool showNetworkError];
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
    
}
/**
 *  发送一个GET请求 网院APP-登录授权接口
 *
 *  @param url     请求路径
 *  @param params  请求参数model
 *  @param success 请求成功后的回调
 *  @param failure 请求失败后的回调
 */

+ (void)getAuthorizedLogin:(NSString *)url params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    [sessionManager.requestSerializer setValue:@"ableskyapp,ios" forHTTPHeaderField:@"User-Agent"];
    [sessionManager.requestSerializer  setValue:@"http://studyapp.enaea.edu.cn/login.do" forHTTPHeaderField:@"Referer"];
    sessionManager.responseSerializer.acceptableContentTypes = [NSSet setWithObject:@"text/plain"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager GET:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (failure) {
            //            [SCTools showErrorWithStatus:@"加载失败"];
            [SCHttpTool showNetworkError];
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
    
}


+ (void)post:(NSString *)url paramsDic:(NSDictionary *)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    //    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.responseSerializer.acceptableContentTypes = nil;
    [sessionManager.requestSerializer setValue:Grtapp forHTTPHeaderField:@"User-Agent"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager POST:url parameters:params headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (failure) {
            //            [SCTools showErrorWithStatus:@"加载失败"];
            [SCHttpTool showNetworkError];
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
    
}

//培训信息管理系统接口
+ (void)xxapiGet:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.responseSerializer.acceptableContentTypes = nil;
    [sessionManager.requestSerializer setValue:XXapiSourceDomain forHTTPHeaderField:@"source-domain"];
    [sessionManager.requestSerializer setValue:token forHTTPHeaderField:@"X-Grt-UserToken"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager GET:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (failure) {
            NSLog(@"error = %@",error);
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
}
+ (void)xxapiGet:(NSString *)url token:(NSString *)token rootSelId:(NSString *)rootSelId params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.responseSerializer.acceptableContentTypes = nil;
    [sessionManager.requestSerializer setValue:XXapiSourceDomain forHTTPHeaderField:@"source-domain"];
    [sessionManager.requestSerializer setValue:token forHTTPHeaderField:@"X-Grt-UserToken"];
    [sessionManager.requestSerializer setValue:@"selUser" forHTTPHeaderField:@"X-Grt-App"];
    [sessionManager.requestSerializer setValue:rootSelId forHTTPHeaderField:@"X-Grt-rootSelId"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager GET:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (failure) {
            NSLog(@"error = %@",error);
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
}
//学习公社云接口
+ (void)xxapiPost:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    [sessionManager.requestSerializer setValue:XXapiSourceDomain forHTTPHeaderField:@"source-domain"];
    [sessionManager.requestSerializer setValue:token forHTTPHeaderField:@"X-Grt-UserToken"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager POST:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (failure) {
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
}
+ (void)xxapiPost:(NSString *)url token:(NSString *)token rootSelId:(NSString *)rootSelId  params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    [sessionManager.requestSerializer setValue:XXapiSourceDomain forHTTPHeaderField:@"source-domain"];
    [sessionManager.requestSerializer setValue:token forHTTPHeaderField:@"X-Grt-UserToken"];
    [sessionManager.requestSerializer setValue:@"selUser" forHTTPHeaderField:@"X-Grt-App"];
    [sessionManager.requestSerializer setValue:rootSelId forHTTPHeaderField:@"X-Grt-rootSelId"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager POST:url parameters:dicParams headers:nil progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (failure) {
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
}

+ (void)xxapiImagePost:(NSString *)url  imageFileName:(NSString *)imageFileName  imgData:(NSData *)imgData token:(NSString *)token rootSelId:(NSString *)rootSelId  params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure
{
    
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.requestSerializer.timeoutInterval = 10;
    //formData: 专门用于拼接需要上传的数据,在此位置生成一个要上传的数据体
    [sessionManager POST:url parameters:nil headers:nil constructingBodyWithBlock:^(id<AFMultipartFormData>  _Nonnull formData) {
        // 在网络开发中，上传文件时，是文件不允许被覆盖，文件重名
        // 要解决此问题，
        // 可以在上传时使用当前的系统事件作为文件名
        NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
        // 设置时间格式
        formatter.dateFormat = @"yyyyMMddHHmmss";
        NSString *str = [formatter stringFromDate:[NSDate date]];
//        NSString *fileName = [NSString stringWithFormat:@"%1@.png", str];
        NSString *fileName = [NSString stringWithFormat:@"%@.png", imageFileName];
        //上传
        /*
         此方法参数
         1. 要上传的[二进制数据]
         2. 对应网站上[upload.php中]处理文件的[字段"file"]
         3. 要保存在服务器上的[文件名]
         4. 上传文件的[mimeType]
         */
        [formData appendPartWithFileData:imgData name:@"file" fileName:fileName mimeType:@"image/png"];
    } progress:^(NSProgress * _Nonnull uploadProgress) {
        //上传进度
        // @property int64_t totalUnitCount;     需要下载文件的总大小
        // @property int64_t completedUnitCount; 当前已经下载的大小
        // 给Progress添加监听 KVO
        NSLog(@"%f",1.0 * uploadProgress.completedUnitCount / uploadProgress.totalUnitCount);
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        NSLog(@"上传成功 %@", responseObject);
        NSLog(@"%@", responseObject);
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        NSLog(@"上传失败 %@", error);
        //失败
        if (failure) {
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
}




+ (void)xxapiDELETE:(NSString *)url token:(NSString *)token params:(id)params success:(void (^)(id))success failure:(void (^)(NSError *))failure{
    NSDictionary *dicParams = [params mj_keyValues];
    AFHTTPSessionManager *sessionManager = [AFHTTPSessionManager manager];
    sessionManager.responseSerializer.acceptableContentTypes = nil;
    [sessionManager.requestSerializer setValue:XXapiSourceDomain forHTTPHeaderField:@"source-domain"];
    [sessionManager.requestSerializer setValue:token forHTTPHeaderField:@"X-Grt-UserToken"];
    sessionManager.requestSerializer.timeoutInterval = 10;
    [sessionManager DELETE:url parameters:dicParams headers:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        if (success) {
            success(responseObject);
            [sessionManager.session finishTasksAndInvalidate];
        }
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        if (failure) {
            NSLog(@"error = %@",error);
            failure(error);
            [sessionManager.session finishTasksAndInvalidate];
        }
    }];
    
}
#pragma mark - 接口异常 HUD提示
+ (void)showNetworkError{
    //核查网络状况
    Reachability *reach = [Reachability reachabilityForInternetConnection];
    NetworkStatus status = [reach currentReachabilityStatus];
    if (status == NotReachable) {
        [SCTools showErrorWithStatus:@"当前网络不可用，请检查你的网络设置"];
    }else{
        [SCTools showErrorWithStatus:@"网络异常"];
    }
}

+ (void)checkNetworkStatus {
    Reachability *reach = [Reachability reachabilityForInternetConnection];
    NetworkStatus status = [reach currentReachabilityStatus];
    if (status == NotReachable) {
        [SCTools showErrorWithStatus:@"网络异常"];
    }
}

@end
