//
//  SigninPromptController.m
//  BaseStudyCommune
//
//  Created by apple-pc on 2021/8/17.
//  Copyright © 2021 enaea. All rights reserved.
//

#import "SigninPromptController.h"
#import "UIButton+Extension.h"
#import "PrefixHeader.pch"
@interface SigninPromptController ()
/// 操作按钮
@property (nonatomic, strong) UIButton *actionButton;
@property (strong, nonatomic) NSTimer *countDownTimer;//定时器
@end

@implementation SigninPromptController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
   self.view.backgroundColor = [[UIColor blackColor] colorWithAlphaComponent:0.3];
    [[NSNotificationCenter defaultCenter]addObserver:self selector:@selector(Facesignindismiss) name:Face_signindismiss object:nil];
    self.topcon.constant = (ScreenHeight - self.SignInView.frame.size.height)/2;
    self.SignInView.backgroundColor = [[UIColor whiteColor]colorWithAlphaComponent:1.0];
    self.SignInView.layer.masksToBounds = YES;
    self.SignInView.layer.cornerRadius = 8.f;
    
    [self.actionButton setTitle:self.actionButtonTitle forState:UIControlStateNormal];
    [self setupButton];
    if (self.type == LiveType)
    {
        [self.closeBtn setImage:[UIImage imageNamed:@"Dm_close"] forState:UIControlStateNormal ];
        [self.closeBtn setTitle:@"" forState:UIControlStateNormal];
        self.titleLabel.hidden = NO;
        self.titleLabel.text = @"开始点名";
        self.CountdownView.hidden = NO;
        self.closeBtn.hidden = NO;
        //format of minute

        NSString *str_minute = [NSString stringWithFormat:@"%02ld",_second/60];

        //format of second

        NSString *str_second = [NSString stringWithFormat:@"%02ld",_second%60];
        self.mm1.text = [str_minute substringWithRange:NSMakeRange(0, 1)];
        self.mm2.text = [str_minute substringWithRange:NSMakeRange(1, 1)];
        self.ss1.text = [str_second substringWithRange:NSMakeRange(0, 1)];
        self.ss2.text = [str_second substringWithRange:NSMakeRange(1, 1)];
       
        _countDownTimer = [NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(countDownAction) userInfo:nil repeats:YES]; //启动倒计时后会每秒钟调用一次方法 countDownAction
    }else
    {
        self.closeBtn.hidden = YES;
        self.titleLabel.text = @"签到";
        self.titleLabel.hidden = NO;
        self.CountdownView.hidden = YES;
        self.nrlabel.text = self.Nrtitle;
    }
}
-(void) countDownAction{
    //倒计时-1
    self.second--;
    //format of minute

    NSString *str_minute = [NSString stringWithFormat:@"%02ld",_second/60];

    //format of second

    NSString *str_second = [NSString stringWithFormat:@"%02ld",_second%60];
    self.mm1.text = [str_minute substringWithRange:NSMakeRange(0, 1)];
    self.mm2.text = [str_minute substringWithRange:NSMakeRange(1, 1)];
    self.ss1.text = [str_second substringWithRange:NSMakeRange(0, 1)];
    self.ss2.text = [str_second substringWithRange:NSMakeRange(1, 1)];
    //当倒计时到0时，做需要的操作，比如验证码过期不能提交
    if(self.second==0){
        [_countDownTimer invalidate];
        if (self.delegate && [self.delegate respondsToSelector:@selector(CountdownOver)]) {
            [self.delegate CountdownOver];
            [self dismiss];
        }
    }
}

- (void)dealloc{
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}
- (UIButton *)actionButton {
    if (!_actionButton) {
        CGFloat bgW = 100.f;
        NSLog(@"%f%f",self.SignInView.frame.origin.y,self.SignInView.frame.size.height);
       
        UIView *btnBgView = [[UIView alloc] initWithFrame:CGRectMake((ScreenWidth - bgW)/2, (ScreenHeight - self.SignInView.frame.size.height)/2 + self.SignInView.frame.size.height - 70 , bgW, bgW)];
        btnBgView.backgroundColor = self.SignInView.backgroundColor;
        btnBgView.layer.masksToBounds = YES;
        btnBgView.layer.cornerRadius = bgW/2.f;
        [self.view addSubview:btnBgView];
        
        CGFloat w = 76.f;
        CGFloat x = (bgW-w) / 2.f;
        UIButton *btn = [UIButton buttonWithType:UIButtonTypeCustom];
        btn.frame = CGRectMake(x, x, w, w);
        [btn setTitle:@"签到" forState:UIControlStateNormal];
        [btn setTitleColor:[UIColor whiteColor] forState:UIControlStateNormal];
        [btn setTitleColor:HEXCOLOR(0xA6B8EB) forState:UIControlStateDisabled];
        [btn setBackgroundColor:HEXCOLOR(0x3B70FF)];
        btn.titleLabel.font = [UIFont fontWithName:@"PingFangSC-Medium" size:16.0];
        btn.layer.masksToBounds = YES;
        btn.layer.cornerRadius = w/2.f;
        [btn addTarget:self action:@selector(action4ClockIn:) forControlEvents:UIControlEventTouchUpInside];
        btn.eventTimeInterval = 4.f;
        [btnBgView addSubview:btn];
        _actionButton = btn;
    }
    return _actionButton;
}
- (void)action4ClockIn:(UIButton *)sender {
    switch (_type) {
        case OrdinaryType:
            if (self.delegate && [self.delegate respondsToSelector:@selector(Ordinarysignin)]) {
                [self.delegate Ordinarysignin];
            }
            break;
        case FaceType:
            if (self.delegate && [self.delegate respondsToSelector:@selector(Facesignin)]) {
                [self.delegate Facesignin];
            }
            break;
        case LiveType:
            if (self.delegate && [self.delegate respondsToSelector:@selector(Livesignin)]) {
                [self.delegate Livesignin];
            }
        default:
            break;
    }
    
   
}
- (IBAction)closeBtnclick:(UIButton *)sender {
    [self dismiss];
}
-(void)dismiss
{
    if (self.type == LiveType)
    {
        [_countDownTimer invalidate];
    }
    CATransition *animation = [CATransition animation];
    animation.duration = 0.1;
    animation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    animation.type = kCATransitionFade;
    animation.subtype = kCATransitionFromLeft;
    [self.view.window.layer addAnimation:animation forKey:nil];
    
    [self dismissViewControllerAnimated:NO completion:nil];
}
- (void)setupButton {
    CGRect buttonFrameInOverView = [self.actionButton convertRect:self.actionButton.bounds toView:self.view];
    CAShapeLayer *layer = [CAShapeLayer new];
    layer.lineWidth = 6.f;
    layer.strokeColor = HEXCOLOR(0x3B70FF).CGColor;
    layer.fillColor = [UIColor clearColor].CGColor;
    CGFloat radius = CGRectGetWidth(buttonFrameInOverView)/2.f + layer.lineWidth/2.f - 0.5;
    BOOL clockWise = false;
    UIBezierPath *path = [UIBezierPath bezierPathWithArcCenter:CGPointMake(CGRectGetMidX(buttonFrameInOverView), CGRectGetMidY(buttonFrameInOverView)) radius:radius startAngle:0 endAngle:2.0f*M_PI clockwise:clockWise];
    layer.path = [path CGPath];
    [self.view.layer addSublayer:layer];
    
    CABasicAnimation *opacityAnimation = [CABasicAnimation animationWithKeyPath:@"opacity"];
    opacityAnimation.fromValue = [NSNumber numberWithFloat:0.3];
    opacityAnimation.toValue = [NSNumber numberWithFloat:0];
    opacityAnimation.removedOnCompletion = NO;
    opacityAnimation.duration = 1.f;
    opacityAnimation.autoreverses = YES;   //是否重播，原动画的倒播
    opacityAnimation.repeatCount = NSNotFound;//HUGE_VALF;     //HUGE_VALF,源自math.h
    opacityAnimation.timingFunction = [CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    [layer addAnimation:opacityAnimation forKey:@"opacityAnimation"];
}
- (void)Facesignindismiss {
    [self dismiss];
}



@end
