#import "GenseePlugin.h"
#import "LiveCourseEnterVC.h"

@interface GenseePlugin()<FlutterStreamHandler>
@end
@implementation GenseePlugin
{
    /// 用于主动传值给flutter的桥梁.
    FlutterEventSink _eventSink;
}

+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"gensee_plugin"
            binaryMessenger:[registrar messenger]];
  GenseePlugin* instance = [[GenseePlugin alloc] init];
    FlutterEventChannel *eventChannel = [FlutterEventChannel eventChannelWithName:@"ios_to_flutter" binaryMessenger:[registrar messenger]];
//    设置代理
       [eventChannel setStreamHandler:instance];

   
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    
    FlutterAppDelegate* delegate = (FlutterAppDelegate*)[[UIApplication sharedApplication]delegate];
        FlutterViewController* rootVC = (FlutterViewController*)delegate.window.rootViewController;
   
    if([@"seelive" isEqualToString:call.method])
    {
        
        NSDictionary *message = call.arguments[@"message"];
        NSLog(@"%@",message);

//                liveVC *livevc = [[liveVC alloc]init];
        LiveCourseEnterVC *livevc = [[LiveCourseEnterVC alloc]init];
        GSPJoinParam *param = [GSPJoinParam new];
        param.domain = message[@"domain"];
        param.serviceType = GSBroadcastServiceTypeTraining;
        param.roomNumber = message[@"roomNumber"];
        param.watchPassword = message[@"watchPassword"];
        param.nickName = message[@"nickName"];
        livevc.param = param;
        livevc.liveName = message[@"liveName"];
        livevc.eventSink = _eventSink;
//        [rootVC presentViewController:livevc animated:YES completion:nil];
        NSLog(@"%@", rootVC.navigationController);
        if([[[UIApplication sharedApplication] keyWindow].rootViewController isKindOfClass:[UINavigationController class]]) {
               UINavigationController *vc = (UINavigationController *)[[UIApplication sharedApplication] keyWindow].rootViewController;
               [vc pushViewController:livevc animated:YES];
           } else {
               UINavigationController *vc = (UINavigationController *)[[UIApplication sharedApplication] keyWindow].rootViewController;
               [vc presentViewController:livevc animated:YES completion:nil];
           }
//        [rootVC.navigationController pushViewController:livevc animated:YES];
        result (@"我去看直播了......");
    }
    //iOS 原生传递给flutter方法
    else if ([@"callNativeMethond" isEqualToString:call.method])
    {
        NSString *message = call.arguments;
       
       
        NSLog(@"%@",message);
    }else {
    result(FlutterMethodNotImplemented);
  }
}
/**
 FlutterAppDelegate* delegate = (FlutterAppDelegate*)[[UIApplication sharedApplication]delegate];
     FlutterViewController* rootVC = (FlutterViewController*)delegate.window.rootViewController;
     
     LoginForm* form = [LoginForm new];
     form.IP = call.arguments[@"IP"];
     form.port = call.arguments[@"port"];
     form.userName = call.arguments[@"userName"];
     form.password = call.arguments[@"password"];
     form.name = call.arguments[@"name"];
     form.describe = call.arguments[@"describe"];
     
     [DHAPI IPLogin:form success:^(LoginResult * _Nonnull result) {
         NSLog(@"登录成功：loginID = %ld,channel = %d",result.loginId,result.channel);
         LivePreviewViewController* vc = [LivePreviewViewController new];
         vc.loginInfo = result;
         
         [rootVC presentViewController:vc animated:YES completion:nil];
         
 
 */
//翻了下官方文档 Invoked when the last listener is deregistered from the Stream associated to this channel on the Flutter side. 大致意思是stream关联的这个通道监听器取消后调用,找了下flutter的dart代码，没取消监听的方法 后面再说吧 待解
- (FlutterError * _Nullable)onCancelWithArguments:(id _Nullable)arguments {
    _eventSink = nil;
    return nil;
}
/**********原生主动传值给flutter-Start**********/
//flutter开始进行监听，并在此方法传入 原生主动传值给flutter的桥梁 event
- (FlutterError * _Nullable)onListenWithArguments:(id _Nullable)arguments eventSink:(nonnull FlutterEventSink)events {
    NSLog(@"flutter开始进行监听，并在此方法传入 原生主动传值给flutter的桥梁 event");
    _eventSink = events;
    return nil;
}

@end
